#include "StdAfx.h"
#include "ScriptExecutor.h"
#include <fstream>
#include <io.h>
#include <fcntl.h>

CScriptExecutor::CScriptExecutor(void)
{
	m_hWorkThread = NULL;
	m_hWorkEvent = NULL;
	m_hLogThread = NULL;
	m_hLogEvent = NULL;
	m_bStatus = FALSE;
	m_nRunType = 0;
	m_hStdOutRead = NULL;
	m_hStdOutWrite = NULL;
	m_hStdErrorWrite = NULL;
	m_hOldStdOutWrite = NULL;

	memset(m_szScriptPath, 0, MAX_PATH);
	memset(m_szLogPath, 0, MAX_PATH);
	memset(m_szExtraSentence, 0, MAX_PATH);

	memset(&m_si, 0, sizeof(m_si));
	memset(&m_pi, 0, sizeof(m_pi));
	m_si.cb = sizeof(m_si);

	m_bKillProcess = FALSE;
	m_bStopLogExport = FALSE;
	m_dwThreadId = 0;
	m_dwSubprocessId = 0;
	m_bRuned = FALSE;
}

CScriptExecutor::~CScriptExecutor(void)
{
}

DWORD CScriptExecutor::_WorkerThread(LPVOID lpParam)
{
	CScriptExecutor* that = (CScriptExecutor*)lpParam;
	if ( !that )
	{
		printf("Error:ʧЧ\n");
		return -1;
	}

	if ( that->m_nRunType == EMBEDDED )
	{
		that->RedirectProcessStdout();
		ResumeThread(that->m_hLogThread);
		that->RunEmbeddedScript();
	}
	else if (that->m_nRunType == SUBPROCESS)
	{
		that->RunScripProcess();
	}

	CloseHandle(that->m_hWorkThread);
	that->m_hWorkThread = NULL;

	// ־߳;
	that->m_bStopLogExport = TRUE;

	return 0;
}

DWORD CScriptExecutor::_LogExportThread(LPVOID lpParam)
{
	CScriptExecutor* that = (CScriptExecutor*)lpParam;
	if (!that)
	{
		printf("Error:ʧЧ\n");
		return -1;
	}

	if (that->m_nRunType == SUBPROCESS)
	{
		DWORD dwRead;
		CHAR chBuf[BUFSIZE] = {0};
		BOOL bSuccess = FALSE;
		
		do
		{
			bSuccess = ReadFile(that->m_hStdOutRead, chBuf, BUFSIZE, &dwRead, NULL);
			if (!bSuccess || dwRead == 0 || !_tcslen(chBuf)) 
				continue;

			Global::WritePythonLog(that->m_szLogPath, chBuf);
			memset(chBuf, 0, BUFSIZE);
		} while (!that->m_bStopLogExport);
	}
	else if ( that->m_nRunType == EMBEDDED)
	{
		DWORD dwRead;
		CHAR chBuf[BUFSIZE] = {0};
		BOOL bSuccess = FALSE;

		do
		{	
			bSuccess = ReadFile(that->m_hStdOutRead, chBuf, BUFSIZE, &dwRead, NULL);
			if (!bSuccess || dwRead == 0 || !_tcslen(chBuf)) 
				continue;

			Global::WritePythonLog(that->m_szLogPath, chBuf);
			memset(chBuf, 0, BUFSIZE);
		} while (!that->m_bStopLogExport);
	}

	// ر߳̾;
	CloseHandle(that->m_hLogThread);
	that->m_hLogThread = NULL;

	// ض;
	that->EndSubprocessStdOut();

	return 0;
}

int CScriptExecutor::RedirectSubprocessStdout(LPSTARTUPINFO si /*=NULL*/)
{
#ifdef _DEBUG
	OutputDebugString("RedirectSubprocessStdout\n");
#endif

	// Pythonű,ʹsys.__stdout__()
	if (m_nRunType == SUBPROCESS)
	{
		SECURITY_ATTRIBUTES sa;
		sa.bInheritHandle = TRUE;
		sa.lpSecurityDescriptor = NULL;
		sa.nLength = sizeof(sa);

		// stdoutĹܵ;
		if (!CreatePipe(&m_hStdOutRead, &m_hStdOutWrite, &sa, 0))
		{
			OutputDebugString("Error:stdoutܵʧ\n");
			return -1;
		}

		// stderrĹܵ,stderrһstdout,ֱӸƾ;
		if (!DuplicateHandle(GetCurrentProcess(), m_hStdOutWrite, GetCurrentProcess(), &m_hStdErrorWrite, 0, TRUE, DUPLICATE_SAME_ACCESS))
		{
			OutputDebugString("stderrܵʧ\n");
			return -2;
		}

		si->dwFlags |= STARTF_USESTDHANDLES;
		// ӽ̵stdouthStdOutWrite;
		si->hStdOutput = m_hStdOutWrite;
		// ӽ̵stderrhStdErrWrite;
		si->hStdError = m_hStdErrorWrite;

		return 0;
	}

	// 쳣;
	OutputDebugString("Error:쳣\n");

	return -5;
}

int CScriptExecutor::RedirectProcessStdout()
{
#ifdef _DEBUG
	OutputDebugString("RedirectProcessStdout\n");
#endif
	if (m_nRunType == EMBEDDED)
	{
		// stdoutĹܵ;
		if (!CreatePipe(&m_hStdOutRead, &m_hStdOutWrite, NULL, 0))
		{
			printf("Error:stdoutܵʧ\n");
			return -1;
		}

		//  C ʱļвϵͳļ;
		int wpfd = _open_osfhandle((intptr_t)m_hStdOutWrite, _O_TEXT);
		// Ϊstdoutļ;
		if (_dup2(wpfd, _fileno(stdout)) != 0)
		{
			printf("Error:dup2ʧ");
			return -2;
		}
		_close(wpfd);

		// ݽԭʼ׼;
		m_hOldStdOutWrite = GetStdHandle(STD_OUTPUT_HANDLE);
		// 豸̱׼,ض򵽹ܵ;
		if (!SetStdHandle(STD_OUTPUT_HANDLE, m_hStdOutWrite))
		{
			printf("Error:ضʧ\n");
			return -3;
		}

		// ñ׼ʹû,ʱд;
		setvbuf(stdout, NULL, _IONBF, 0);

		return 0;
	}

	// 쳣;
	printf("Error:쳣\n");

	return -5;
}

void CScriptExecutor::CatchPythonException()
{
	if (!Py_IsInitialized())
	{
		printf("Error:δʼPython\n");
		return;
	}

	if (!PyErr_Occurred())
	{
		printf("Error:û쳣\n");
		return;
	}

	// 쳣;
	const char* pszErrMsg = NULL;
	TCHAR* pszTraceback = NULL;

	PyObject* pPyType = NULL;
	PyObject* pPyValue = NULL;
	PyObject* pPyTraceback = NULL;
	// ǿ̨,ʹPyErr_Fetch쳣;
	PyErr_Fetch(&pPyType, &pPyValue, &pPyTraceback);
	PyErr_NormalizeException(&pPyType, &pPyValue, &pPyTraceback); // п,Ӱȡ쳣;
	if (pPyValue)
	{
		PyObject* pPyStr = PyObject_Str(pPyValue);
		if (PyString_Check(pPyStr))
		{
			pszErrMsg = PyString_AsString(pPyStr);
			if (pszErrMsg)
				printf("Error Info=>%s\n", pszErrMsg);

			if (pPyTraceback)
			{
				PyObject* pPyTraceModule = PyImport_ImportModule("traceback");
				if (!pPyTraceModule)
				{
					printf("Error:tracebackģʧ\n");
					return;
				}
#if 1 // ϸֳлз;
				PyObject* pPyModuleDict = PyModule_GetDict(pPyTraceModule);
				if (pPyModuleDict)
				{
					PyObject* pPyFunc = PyDict_GetItemString(pPyModuleDict, "format_exception");
					if (!pPyFunc || !PyCallable_Check(pPyFunc))
					{
						printf("Error:format_exceptionʧ\n");
						return;
					}

					PyObject* pErroList = PyObject_CallFunctionObjArgs(pPyFunc, pPyType, pPyValue, pPyTraceback, NULL);
					if (pErroList)
					{
						int nSize = PyList_Size(pErroList);
						for (int i = 0; i < nSize; i++)
						{
							pszErrMsg = PyString_AsString(PyList_GetItem(pErroList, i));
							printf("%s", pszErrMsg);
						}
					}
					Py_DECREF(pErroList);
				}

				Py_XDECREF(pPyTraceModule);
#else // ϸItem;
				PyObject* pPyFunc = PyObject_GetAttrString(pPyTraceModule, "format_exception");
				if (!pPyFunc || !PyCallable_Check(pPyFunc))
				{
					printf("Error:format_exceptionʧ\n");
					return;
				}

				PyObject* pPyResult = PyObject_CallFunctionObjArgs(pPyFunc, pPyType, pPyValue, pPyTraceback, NULL);
				pPyStr = PyObject_Str(pPyResult);
				pszErrMsg = PyString_AsString(pPyStr);
				if (pszErrMsg)
					printf("%s\n", pszErrMsg);

				Py_DECREF(pPyResult);
				Py_XDECREF(pPyTraceModule);
#endif
			}
		}
	}

	Py_XDECREF(pPyType);
	Py_XDECREF(pPyValue);
	Py_XDECREF(pPyTraceback);
}

int CScriptExecutor::RunEmbeddedScript()
{
	// Чж;
	if (!PathFileExists(m_szScriptPath))
	{
		printf("Error:űļ\n");
		return -1;
	}

	// ʼPython;
	if (!Py_IsInitialized())
		Py_Initialize();

	if (!Py_IsInitialized())
	{
		printf("Error:ʼPythonʧ\n");
		return -2;
	}

	// ű·ͽű;
	std::string scriptdir;
	TCHAR szDrive[_MAX_DRIVE] = { 0 };
	TCHAR szDir[_MAX_DIR] = { 0 };
	TCHAR szExt[_MAX_EXT] = { 0 };
	TCHAR szFilename[_MAX_FNAME] = { 0 };
	TCHAR szScriptDir[MAX_PATH] = { 0 };
	_tsplitpath_s(m_szScriptPath, szDrive, szDir, szFilename, szExt);
	_stprintf_s(szScriptDir, _T("%s%s"), szDrive, szDir);
	// һ·;
	scriptdir = szScriptDir;
	// '\'ת'/', PythonĿ¼ɹ;
	int len = _tcslen(szScriptDir);
	for (int i = 0; i < len; i++)
	{
		if (szScriptDir[i] == '\\')
			szScriptDir[i] = '/';
	}
	//szScriptDir[len-1] = '\0';

	TCHAR szExecuteDir[MAX_PATH] = { 0 };
	_stprintf_s(szExecuteDir, _T("sys.path.append(\"%s\")"), szScriptDir);
	// ϵͳģ,ָǰű·Ϊ·;
	PyRun_SimpleString("import sys");
	PyRun_SimpleString(szExecuteDir);
	// ж,һڴв;
	if (_tcslen(m_szExtraSentence))
		PyRun_SimpleString(m_szExtraSentence);

	// ע⣺űƾҪϵͳĿ¼pyļͬ;
	// űԽűΪģ;
	PyObject* pModuleObj = PyImport_ImportModule(szFilename);
	if (!pModuleObj)
	{
		printf("Error:ؽűģʧ\n");
		Py_Finalize();
		return -3;
	}

	// ȡű(涨нűΪmain)
	// غע⣬Ŀ¼ͬĽűļܻʧ;
	PyObject* pFunction = PyObject_GetAttrString(pModuleObj, "main");
	if (!pFunction || !PyCallable_Check(pFunction))
	{
		printf("Error:غʧ\n");
		Py_Finalize();
		return -4;
	}

	m_bRuned = TRUE; 
	// ִmain;
	PyObject* pResult = PyObject_CallObject(pFunction, NULL);
	if (!pResult)
	{
		printf("Error:ִкʧ\n");
		CatchPythonException();
		Py_Finalize();
		
		return -5;
	}

	Py_DECREF(pResult);

	Py_Finalize();

	return 0;
}

int CScriptExecutor::RunScripProcess()
{
	if (!PathFileExists(m_szScriptPath))
	{
		printf("Error:ű·Ч\n");
		return -1;
	}

	// ʼ;
	::memset(&m_si, 0, sizeof(m_si));
	::memset(&m_pi, 0, sizeof(m_pi));
	m_si.cb = sizeof(m_si);
	GetStartupInfo(&m_si); 

	// ǿstdion, stdoutstderrȫ޻:python -u
	TCHAR szCommandLine[MAX_PATH] = { 0 };
	if (_tcslen(m_szExtraSentence))
		_stprintf_s(szCommandLine, _T("python -W ignore -u %s %s"), m_szScriptPath, m_szExtraSentence);
	else
		_stprintf_s(szCommandLine, _T("python -W ignore -u %s"), m_szScriptPath);

	// ض;
	RedirectSubprocessStdout(&m_si);
	// ָ־߳;
	ResumeThread(m_hLogThread);

	// ӽ;
	if (!CreateProcess(
		NULL,					// No module name (use command line)
		szCommandLine,			// Command line
		NULL,					// Process handle not inheritable
		NULL,					// Thread handle not inheritable
		TRUE,					// Set handle inheritance to TRUE
		0,						// No creation flags
		NULL,					// Use parent's environment block
		NULL,					// Use parent's starting directory 
		&m_si,					// Pointer to STARTUPINFO structure
		&m_pi)					// Pointer to PROCESS_INFORMATION structure
		)
	{
		printf("Error:ӽʧ (%d).\n", GetLastError());
		return -3;
	}

	m_bRuned = TRUE;
	m_dwSubprocessId = m_pi.dwProcessId;
	// ȴ˳.
	WaitForSingleObject(m_pi.hProcess, INFINITE);

	Sleep(5000);
	// ־߳;
	m_bStopLogExport = TRUE;

	// رս̾. 
	CloseHandle(m_pi.hProcess);
	CloseHandle(m_pi.hThread);

	// ;
	memset(&m_si, 0, sizeof(m_si));
	memset(&m_pi, 0, sizeof(m_pi));
	m_si.cb = sizeof(m_si);

	return 0;
}

bool CScriptExecutor::StartWorkThread()
{
	// ߳;
	m_hWorkThread = CreateThread(NULL, 0, _WorkerThread, this, 0, &m_dwThreadId);
	if (!m_hWorkThread)
	{
		printf("Error:߳ʧ\n");
		return false;
	}

	return true;
}

bool CScriptExecutor::StartLogThread()
{
	printf("StartLogThread\n");
	// ߳¼:ֶ,ź״̬;
	m_hLogEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
	if (!m_hLogEvent)
	{
		printf("Error:޷Ϊ̴߳¼\n");
		return false;
	}

	// ߳;
	m_hLogThread = CreateThread(NULL, 0, _LogExportThread, this, CREATE_SUSPENDED, NULL);
	if (!m_hLogThread)
	{
		printf("Error:߳ʧ\n");
		CloseHandle(m_hLogEvent);
		m_hLogEvent = NULL;

		return false;
	}

	return true;
}

void CScriptExecutor::EndWorkThread()
{
	// ȴ߳̽;
	if (m_hWorkThread)
	{
		// 5νΪ;
		for (int i = 0; i < 5; i++)
		{
			if (TerminateThread(m_hWorkThread, 0))
				break;
		}

		CloseHandle(m_hWorkThread);
		m_hWorkThread = NULL;
	}
}

void CScriptExecutor::EndLogThread()
{
	// ¼ź;
	if (m_hLogEvent)
		SetEvent(m_hLogEvent);

	// ȴ߳̽;
	if (m_hLogThread)
	{
		WaitForSingleObject(m_hLogThread, INFINITE);
		CloseHandle(m_hLogThread);
		m_hLogThread = NULL;
	}

	// رվ;
	if (m_hLogEvent)
		CloseHandle(m_hLogEvent);
	m_hLogEvent = NULL;
}

void CScriptExecutor::EndThread(HANDLE hThread, HANDLE hEvent)
{
	// ¼ź;
	if (hEvent)
		SetEvent(hEvent);

	// ȴ߳̽;
	if (hThread)
	{
		WaitForSingleObject(hThread, INFINITE);
		CloseHandle(hThread);
		hThread = NULL;
	}

	// رվ;
	if (hEvent)
		CloseHandle(hEvent);
	hEvent = NULL;
}

BOOL CScriptExecutor::EndSubprocess()
{
	BOOL ret = false;
	if (m_pi.hProcess)
	{
		// 5ν;
		for (int i = 0; i < 5; i++)
		{
			if ( (ret = TerminateProcess(m_pi.hProcess, 0)) )
				break;
		}
	}

	return ret;
}

void CScriptExecutor::EndProcessStdOut()
{
	OutputDebugString("--------------EndProcessStdOut----------------\n");
#if 0 // ָʧ,
	// ָ׼Ƕ̽ű;
	if ( m_nRunType == EMBEDDED && m_hOldStdOutWrite)
	{
		int fn = _fileno(stdout);
		// ָĬϱ׼;
		int fd = _open_osfhandle((intptr_t)m_hOldStdOutWrite, _O_RDWR);
		if ( _dup2(fd, _fileno(stdout)) == 0)
		{
			_close(fd);
			// ñ׼;
			SetStdHandle(STD_OUTPUT_HANDLE, m_hOldStdOutWrite);
			m_hOldStdOutWrite = NULL;
			// ñ׼ʹû,ʱд;
			setvbuf(stdout, NULL, _IONBF, 0);
		}
		else
		{
			printf("Error:_dup2ļʧ\n");
		}			
	}
#endif

	// رض;
	if (m_hStdErrorWrite)
		CloseHandle(m_hStdErrorWrite);
	m_hStdErrorWrite = NULL;

	// ֻӽ̷ʽŹرվ;
	if ( m_hStdOutWrite)
		CloseHandle(m_hStdOutWrite);
	m_hStdOutWrite = NULL;

	if (m_hStdOutRead)
		CloseHandle(m_hStdOutRead);
	m_hStdOutRead = NULL;	
}

void CScriptExecutor::EndSubprocessStdOut()
{
	OutputDebugString("--------------EndSubprocessStdOut----------------\n");
	// رض;
	if (m_hStdErrorWrite)
		CloseHandle(m_hStdErrorWrite);
	m_hStdErrorWrite = NULL;

	// ֻӽ̷ʽŹرվ;
	if ( m_hStdOutWrite)
		CloseHandle(m_hStdOutWrite);
	m_hStdOutWrite = NULL;

	if (m_hStdOutRead)
		CloseHandle(m_hStdOutRead);
	m_hStdOutRead = NULL;	
}

void CScriptExecutor::InitScript(std::string strScript, std::string strLogPath, std::string strScriptCmd, int nRunType /*= PY_RUN_TYPE::EMBEDDED*/)
{
	// жϽűǷ;
	if (!PathFileExists(strScript.c_str()))
	{
		printf("Error:űļ\n");
		return;
	}

	// ж־ļ·Ƿɴ;
	if (!PathFileExists(strLogPath.c_str()))
	{
		// ·;
		if (!Global::MKDIR(strLogPath.c_str()))
		{
			printf("Error:Ŀ¼ʧ\n");
			return;
		}

		// ļ;
		std::ofstream flog(strLogPath.c_str());
		if ( flog.bad() )
		{
			printf("Error:ļʧ\n");
			return;
		}
		flog.close();
	}

	// ֵ;
	m_bRuned = FALSE;
	m_nRunType = nRunType;
	m_dwThreadId = m_dwSubprocessId = 0;
	_tcscpy_s(m_szScriptPath, strScript.c_str());
	_tcscpy_s(m_szLogPath, strLogPath.c_str());
	_tcscpy_s(m_szExtraSentence, strScriptCmd.c_str());
}

bool CScriptExecutor::StartScript()
{
	if (StartWorkThread())
	{
		// ־߳;
		if (!StartLogThread())
		{
			printf("Error:־̴߳\n");
		}

		Sleep(100);

		return true;
	}

	// 쳣;
	printf("Error:쳣ͽű\n");

	return false;
}

void CScriptExecutor::StopScript()
{
	// ӽнű,ֹͣ߳ʱkill;
	if (m_nRunType == SUBPROCESS)
		EndSubprocess();

	// ߳;
	EndWorkThread();
}

bool CScriptExecutor::IsScriptOver()
{
	int i = 10;
	while (!m_bRuned)
	{
		Sleep(300);
		if ( --i == 0 )
			break;
	}

	if (m_nRunType == EMBEDDED)
	{
		if ( m_hWorkThread == NULL )
			return true;
	}
	else if (m_nRunType == SUBPROCESS)
	{
		if ( m_pi.hProcess == NULL && m_hWorkThread == NULL )
			return true;
	}

	return false;
}