#ifndef __SCRIPT_EXECUTOR__
#define __SCRIPT_EXECUTOR__

#pragma once

#define BUFSIZE 4096
enum PY_RUN_TYPE
{
	EMBEDDED,			// Ƕ뵽;
	SUBPROCESS			// ӽ̷ʽ;
};

class CScriptExecutor
{
public:
	CScriptExecutor(void);
	~CScriptExecutor(void);

protected:
	HANDLE			m_hWorkThread;						// ¼;
	HANDLE			m_hWorkEvent;						// ߳¼;
	HANDLE			m_hLogThread;						// ¼;
	HANDLE			m_hLogEvent;						// ߳¼;
	BOOL			m_bStatus;							// ߳״̬;
	TCHAR			m_szScriptPath[MAX_PATH];			// ű·;
	TCHAR			m_szLogPath[MAX_PATH];				// ־·;	
	TCHAR			m_szExtraSentence[MAX_PATH];		// űвҪִе;
	int				m_nRunType;
	// ض׼ͱ׼;
	HANDLE			m_hStdOutRead;
	HANDLE			m_hStdOutWrite;
	HANDLE			m_hStdErrorWrite;
	HANDLE			m_hOldStdOutWrite;					// ڱ̱׼;
	// ӽϢ;
	STARTUPINFO			m_si;
	PROCESS_INFORMATION	m_pi;
	// ̽־;
	BOOL			m_bKillProcess;
	// ֹͣ־߳;
	BOOL			m_bStopLogExport;
	// ִִʱ;
	CTime			m_tStartTime;
	// ִʱ;
	CTime			m_tEndTime;
	// ӽID;
	DWORD			m_dwSubprocessId;
	// ߳ID;
	DWORD			m_dwThreadId;
	// űǷɹ;
	BOOL			m_bRuned;
protected:
	// ̺߳;
	static DWORD WINAPI _WorkerThread(LPVOID lpParam);
	// ־߳;
	static DWORD WINAPI _LogExportThread(LPVOID lpParam);
	// ض򱾽̱׼;
	int RedirectProcessStdout();
	// ضӽ׼;
	int RedirectSubprocessStdout(LPSTARTUPINFO si = NULL);	
	// ȡPython쳣;
	void CatchPythonException();
	// ǶĽű;
	int RunEmbeddedScript();
	// нű;
	int RunScripProcess();
	// ߳;
	bool StartWorkThread();
	bool StartLogThread();
	// ߳;
	void EndWorkThread();
	void EndLogThread();
	void EndThread(HANDLE hThread, HANDLE hEvent);
	// ӽ;
	BOOL EndSubprocess();
	// ӹܵȡ־;
	void ReadFromPipe();
	// ض,ָĬ;
	void EndProcessStdOut();
	void EndSubprocessStdOut();
public:
	// ʼűв;
	void InitScript(
		std::string strScript, 
		std::string strLogPath, 
		std::string strScriptCmd, 
		int nRunType = EMBEDDED);
	// нű;
	bool StartScript();
	// ֹͣű;
	void StopScript();
	// űǷ;
	bool IsScriptOver();
	// ;
	int GetRunType() const { return m_nRunType;}
	// ȡűId;
	DWORD GetScriptId() const {
		if ( m_nRunType == SUBPROCESS )
			return m_dwSubprocessId;
		else
			return m_dwThreadId;
	}
};

#endif // __SCRIPT_EXECUTOR__