#include "stdafx.h"
#include "SATClient.h"
//#include <ws2def.h>
#include "DlgProBar.h"

const int SOCK_TCP = SOCK_STREAM - 1;
const int SOCK_UDP = SOCK_DGRAM - 1;
const int AF_IPV4 = 0;
const int AF_IPV6 = 1;
#define PAK_LEN sizeof(SATProtocol::DataHeader)
#define HEADER_LEN sizeof(SATProtocol::DataHeader)
// ;
CDlgProBar* g_pDlgProBar = NULL;

void CSATClient::OnThreadBegin(CSocketHandle* pSH)
{
	ASSERT(pSH == m_SocketClient);
	(pSH);
	CString strAddr;
	SockAddrIn sockAddr;
	m_SocketClient->GetSockName(sockAddr);
	GetAddress(sockAddr, strAddr);
	InitializeCriticalSection(&pSH->m_hClient2SrvSection);
}

void CSATClient::OnThreadExit(CSocketHandle* pSH)
{
	ASSERT(pSH == m_SocketClient);
	DeleteCriticalSection(&pSH->m_hClient2SrvSection);
	m_bSocket = FALSE;
	TRACE(_T("======߳˳.\r\n"));
	(pSH);
}

void CSATClient::OnDataReceived(CSocketHandle* pSH, const BYTE* pbData, DWORD dwCount, const SockAddrIn& addr)
{
	ASSERT(pSH == m_SocketClient);
	(pSH);

	if (!m_SocketClient->IsOpen()) return;

	OnReceive(pbData, dwCount);
}

void CSATClient::OnConnectionDropped(CSocketHandle* pSH)
{
	ASSERT(pSH == m_SocketClient);
	(pSH);
	TRACE(_T("======ӷϿ.\r\n"));

	m_bSocket = FALSE;
}

void CSATClient::OnConnectionError(CSocketHandle* pSH, DWORD dwError)
{
	ASSERT(pSH == m_SocketClient);
	(pSH);
	_com_error err(dwError);

	m_bSocket = FALSE;
}

CSATClient::CSATClient(void)
{
	m_nMode = AF_IPV4;
	m_nSockType = SOCK_TCP;
	m_SocketClient.SetInterface(this);
	m_bSocket = FALSE;
}

CSATClient::~CSATClient(void)
{
}

bool CSATClient::OnSend(const byte* pData, int nLen)
{
	if (!m_bSocket) {
		if (!Start())
			return false;
	}

	CDlgProBar dlg;
	g_pDlgProBar = &dlg;
	DWORD dwLen = m_SocketClient.Write((const LPBYTE)pData, nLen);
	if (dwLen == nLen)
	{
		dlg.DoModal();
		OutputDebugString(_T("ݳɹ\n"));
		return true;
	}
	else
	{
		g_pDlgProBar = NULL;
		OutputDebugString(_T("ʧܣ\n"));
	}

	return false;
}

bool CSATClient::OnReceive(const byte* pData, int nLen)
{
	// Сڰͷ;
	SATProtocol::DataHeader* phead = NULL;
	if (lastData.size() == 0)
	{
		// ͷ;
		if (PAK_LEN > nLen)
		{
			OutputDebugString("Aͷ;\n");
			lastData.append((char*)pData, nLen);
		}
		else
		{
			// ͷ;
			phead = (SATProtocol::DataHeader*)pData;

			// İ;
			if (phead->len == nLen)
			{
				OutputDebugString("Aİ;\n");
				TaskProcess((SATProtocol::Package*)pData);
			}
			// С;
			else if (phead->len > nLen)
			{
				OutputDebugString("AС;\n");
				lastData.append((char*)pData, nLen);
			}
			// ;
			else if (phead->len < nLen)
			{
				OutputDebugString("A;\n");
				lastData.append((char*)pData + phead->len, nLen - phead->len);
				TaskProcess((SATProtocol::Package*)pData);
			}
		}
	}
	else
	{
		int lastlen = nLen;
		if (lastData.size() >= PAK_LEN)
		{
			phead = (SATProtocol::DataHeader*)lastData.data();
			if (phead->len <= lastData.size() + nLen)
			{
				if (phead->len <= lastData.size())
				{
					OutputDebugString("C;\n");
					// ;
					TaskProcess((SATProtocol::Package*)lastData.substr(0, phead->len).data());

					lastData = lastData.substr(phead->len);
					lastData.append((char*)pData, nLen);
				}
				else
				{
					OutputDebugString("D;\n");
					lastlen = lastData.size() + nLen - phead->len;
					lastData.append((char*)pData, nLen - lastlen);
					// ;
					TaskProcess((SATProtocol::Package*)lastData.data());
					// ʣ;
					lastData.clear();
					if (lastlen)
						lastData.append((char*)pData + nLen - lastlen, lastlen);
				}
			}
			else
			{
				OutputDebugString("CԲһ;\n");
				lastData.append((char*)pData, nLen);
			}
		}
		else
		{
			// ͷʣ೤;
			int diflen = PAK_LEN - lastData.size();
			// Բһͷ;
			if (diflen > nLen)
			{
				OutputDebugString("BԲһͷ;\n");
				lastData.append((char*)pData, nLen);
			}
			else
			{
				// ƴͷ;
				lastData.append((char*)pData, diflen);
				phead = (SATProtocol::DataHeader*)lastData.data();

				// ;
				if (phead->len == PAK_LEN + nLen - diflen)
				{
					OutputDebugString("B;\n");
					lastData.append((char*)pData + diflen, nLen - diflen);
					TaskProcess((SATProtocol::Package*)lastData.data());
					lastData.clear();
				}
				// С;
				else if (phead->len > PAK_LEN + nLen - diflen)
				{
					OutputDebugString("BС;\n");
					lastData.append((char*)pData + diflen, nLen - diflen);
				}
				// ;
				else if (phead->len < PAK_LEN + nLen - diflen)
				{
					OutputDebugString("B;\n");
					// ɰ;
					lastData.append((char*)pData + diflen, phead->len - PAK_LEN);
					TaskProcess((SATProtocol::Package*)lastData.data());
					lastData.clear();
					int last = nLen - diflen - phead->len + PAK_LEN;
					if (last)
					{
						lastData.append((char*)pData + nLen - last, last);
					}
				}
			}
		}
	}

	return false;
}

bool CSATClient::OnClose()
{
	return false;
}

bool CSATClient::OnConnect()
{
	return false;
}

void CSATClient::TaskProcess(SATProtocol::Package* pak)
{
	SATProtocol::DataHeader* pHeader = &pak->header;
	if (pHeader->protocol == 0xAA) {
#ifdef _DEBUG
		// ӳؿʾʱ;
		Sleep(500);
#endif
		if (g_pDlgProBar) {
			while (!::IsWindow(g_pDlgProBar->m_hWnd));
			g_pDlgProBar->PostMessage(WM_STOPTHREAD);
			g_pDlgProBar = NULL;
		}

		switch (pHeader->cmd)
		{
			case SATProtocol::CMD_LOGIN:
			case SATProtocol::CMD_LOGOUT:
			{
				SATProtocol::LoginResp* resp = (SATProtocol::LoginResp*)pak->buf;
				if (pHeader->cmd == SATProtocol::CMD_LOGIN)
				{
					SATData::logout_resp.bStatus = false;
					SATData::login_resp.bStatus = resp->bStatus;
					_stprintf_s(SATData::login_resp.szMessage, _T("%s"), resp->szMessage);
				}
				else
				{
					SATData::login_resp.bStatus = false;
					SATData::logout_resp.bStatus = resp->bStatus;
					_stprintf_s(SATData::logout_resp.szMessage, _T("%s"), resp->szMessage);
				}
			}
				break;
			case SATProtocol::CMD_ADD_DEVICE:
				break;
			case SATProtocol::CMD_DEL_DEVICE:
				break;
			case SATProtocol::CMD_QUERY_DEVICES:
				break;
			default:
				break;
		}
	}
}

BOOL CSATClient::Start()
{
	int nFamily = (m_nMode == AF_IPV4) ? AF_INET : AF_INET6;
	if (!m_SocketClient.StartClient(NULL, Global::g_Config.strServiceIP.c_str(), Global::g_Config.strSATPassword.c_str(), nFamily, (m_nSockType + 1)))
	{
#ifdef _DEBUG
		OutputDebugString("ӷʧ\n");
#endif
		m_bSocket = FALSE;
		return FALSE;
	}

	// ɹӷ;
	m_bSocket = TRUE;
	CSocketHandle* pSH = (CSocketHandle*)m_SocketClient;

	// õȴΪ0;
	pSH->m_nPendingSize = 0;
	memset(pSH->m_PendingBuffer, 0, SOCKET_BUFFSIZE);

	// öಥ;
	SetupMCAST();
	return TRUE;

}

void CSATClient::Stop()
{
	m_SocketClient.Terminate();
}

bool CSATClient::SetupMCAST()
{
	const TCHAR szIPv4MCAST[] = TEXT("239.121.1.2");
	const TCHAR szIPv6MCAST[] = TEXT("FF02:0:0:0:0:0:0:1"); // All Nodes local address
	bool result = false;
	if (m_nSockType == SOCK_UDP)
	{
		if (m_nMode == AF_IPV4) {
			result = m_SocketClient->AddMembership(szIPv4MCAST, NULL);
		}
		else {
			result = m_SocketClient->AddMembership(szIPv6MCAST, NULL);
			HRESULT hr = HRESULT_FROM_WIN32(GetLastError());
			hr = hr;
		}
	}
	return result;
}

void CSATClient::GetAddress(const SockAddrIn& addrIn, CString& rString) const
{
	TCHAR szIPAddr[MAX_PATH] = { 0 };
	CSocketHandle::FormatIP(szIPAddr, MAX_PATH, addrIn);
	rString.Format(_T("%s : %d"), szIPAddr, static_cast<int>(static_cast<UINT>(ntohs(addrIn.GetPort()))));
}

bool CSATClient::TCPLogin(std::string strUserName, std::string strPassword, BOOL bLogin)
{
	SATData::login_resp = {0};
	int len = HEADER_LEN + sizeof(SATProtocol::UserInfo);
	byte* pbuff = new byte[len];
	memset(pbuff, 0, len);
	SATProtocol::Package* pData = (SATProtocol::Package*)pbuff;

	pData->header.protocol = 0xAA;
	pData->header.len = len;
	pData->header.cmd = bLogin ? SATProtocol::CMD_LOGIN : SATProtocol::CMD_LOGOUT;

	SATProtocol::UserInfo* pUserInfo = (SATProtocol::UserInfo*)pData->buf;
	memcpy(pUserInfo->szUserName, strUserName.c_str(), strUserName.size());
	memcpy(pUserInfo->szPassword, strPassword.c_str(), strPassword.size());

	bool bret = OnSend(pbuff, len);
	delete[]pbuff;

	return bret;
}

bool CSATClient::TCPLogout(std::string strUserName, std::string strPassword)
{
	return TCPLogin(strUserName, strPassword, FALSE);
}
