#ifndef __SAT_CLIENT__
#define __SAT_CLIENT__

#include "SocketHandle.h"
#include "SocketClientImpl.h"
//#include "SATProtocol.h"
#include "SATData.h"

#pragma once
class CSATClient:public ISocketClientHandler
{
	CSATClient(void);
	typedef SocketClientImpl<ISocketClientHandler> CSocketClient;
	friend CSocketClient;
protected:
	// ISocketServerHandler
	virtual void OnThreadBegin(CSocketHandle* pSH);
	virtual void OnThreadExit(CSocketHandle* pSH);
	virtual void OnDataReceived(CSocketHandle* pSH, const BYTE* pbData, DWORD dwCount, const SockAddrIn& addr);
	virtual void OnConnectionDropped(CSocketHandle* pSH);
	virtual void OnConnectionError(CSocketHandle* pSH, DWORD dwError);

public:
	static CSATClient* GetInstance()
	{
		static CSATClient* pInstance = NULL;
		if (pInstance == NULL)
		{
			pInstance = new CSATClient;
		}

		return pInstance;
	}

	~CSATClient(void);

private:
	BOOL m_bSocket;			// Ƿӳɹ;
	int m_nSockType;		// UDP  TCP
	int m_nMode;			// IP4  IP6
	std::string lastData;
	CSocketClient m_SocketClient;
	bool OnSend(const byte* pData, int nLen);
	bool OnReceive(const byte* pData, int nLen);
	bool OnClose();
	bool OnConnect();
	void TaskProcess(SATProtocol::Package *pak);

public:
	// TCPͻʵ;
	BOOL Start();
	// ֹͣTCPͻ;
	void Stop();
	// ಥMulticasting;
	bool SetupMCAST();
	// ȡַ;
	void GetAddress(const SockAddrIn& addrIn, CString& rString) const;

	// ¼;
	bool TCPLogin(std::string strUserName, std::string strPassword, BOOL bLogin = TRUE);
	// ǳ;
	bool TCPLogout(std::string strUserName, std::string strPassword);

	// 豸;
	bool TCPAddDevice(std::string strDevice);
	// ɾ豸;
	bool TCPDelDevice(std::string strDevice);
	// ѯ豸;
	bool TCPQueryDevices(std::vector<std::string> &vtDevices);
};

#endif // __SAT_CLIENT__