#include "StdAfx.h"
#include "SATExecutor.h"
#include "ScriptExecutor.h"
#include "CharEncoding.h"

CSATExecutor::CSATExecutor(void)
{
	m_bLogin = FALSE;
	m_hEventHearbeat = NULL;
	m_hThreadHearbeat = NULL;
	m_hEventExcuteScript = NULL;
	m_hThreadExcuteScript = NULL;
}

CSATExecutor::~CSATExecutor(void)
{
}

bool CSATExecutor::IsTaskExist(SATParameters::STTask &task)
{
	bool found = false;
	std::list<SATParameters::STTask>::iterator it = m_vtTask.begin();
	for ( ; it != m_vtTask.end(); it++ )
	{
		// ҪʹnTaskId,ֵûɶ;
		if ( it->Id == task.Id )
		{
			found = true;
			break;
		}
	}

	return found;
}

SATParameters::STTask* CSATExecutor::IsThereATaskInProcess()
{
	std::list<SATParameters::STTask>::iterator it = m_vtTask.begin();
	for ( ; it != m_vtTask.end(); it++ )
	{
		if ( it->_nExecutionState == 1 )
		{
			return &(*it);
		}
	}

	return NULL;
}

SATParameters::STTask* CSATExecutor::GetFreeTask()
{
	std::list<SATParameters::STTask>::iterator it = m_vtTask.begin();
	for ( ; it != m_vtTask.end(); it++ )
	{
		if ( it->_nExecutionState == 0 )
		{
			return &(*it);
		}
	}

	return NULL;
}

SATParameters::STCase* CSATExecutor::IsCaseScriptProcess(std::vector<SATParameters::STCase> &vtCases)
{
	std::vector<SATParameters::STCase>::iterator it = vtCases.begin();
	for ( ; it != vtCases.end(); it++)
	{
		if ( it->_nExecutionState == 1 )
		{
			return &(*it);
		}
	}

	return NULL;
}

SATParameters::STCase* CSATExecutor::GetFreeCaseScript(std::vector<SATParameters::STCase> &vtCases)
{
	std::vector<SATParameters::STCase>::iterator it = vtCases.begin();
	for ( ; it != vtCases.end(); it++)
	{
		if ( it->_nExecutionState == 0 )
		{
			return &(*it);
		}
	}

	return NULL;
}

SATParameters::STCase* CSATExecutor::ExecuteFreeCaseScript(SATParameters::STTask* pTask)
{
	SATParameters::STCase* pCase = GetFreeCaseScript(pTask->Job.vtCases);
	if (pCase) {		
		if ( !pCase->_pExcutor ) {
			CScriptExecutor *pExcutor = new CScriptExecutor(); 
			if ( pExcutor ) {
				pCase->_pExcutor = pExcutor;
				// ־ļ·;
				pCase->_strCaseLog = pCase->_strFileDir + "\\" + pCase->_strFileName + ".txt";
				if ( pExcutor->InitScript(pCase->_strScriptPath, pCase->_strCaseLog, "", SUBPROCESS) ) {
					pExcutor->StartScript();
					// ִ;
					pCase->_nExecutionState = 1;
				}
				else { // ʼʧ;
					pCase->_nExecutionState = 4;
				}

				// Ϊִ;
				pTask->_nExecutionState = 1;
				// ¼ʼʱ;
				pCase->_ulStartTickCount = GetTickCount64();
				pCase->_strStartTime = CTime::GetCurrentTime().Format(_T("%Y-%m-%d %H:%M:%S"));
			}	
		}
		else {
			//CScriptExecutor *pExcutor = (CScriptExecutor *)pCase->_pExcutor;
		}
	}

	return pCase;
}

bool CSATExecutor::Login(std::string user, std::string password, std::string actuator, bool bLogin /*= true*/)
{
	std::string url = Global::g_stSATConfig.szExecuteServer;
	url.append("/ajaxInteractiveManage!executeLogin.action");
	// ʾֵ;
	m_stLoginReq.strUserName = user;
	m_stLoginReq.strStatus = bLogin ? "0" : "1";   // 0ʾ¼;
	m_stLoginReq.strDeleteStatus = "";
	m_stLoginReq.strIP = Global::GetLocalAddress();//"10.118.158.175";
	m_stLoginReq.strStorage = "";
	m_stLoginReq.strConnectTime = "";
	// ִ;
	m_stLoginReq.strExecuteName = m_strActuatorName;
	if ( Global::g_vtMac.size() )
		m_stLoginReq.strMAC = Global::g_vtMac[0].szMacAddress; // ȡһMACַ;
	else
		m_stLoginReq.strMAC = "";
	m_stLoginReq.strDisconnectTime = "";
	m_stLoginReq.strPassword = password;
	m_stLoginReq.strCPU = "";

	if ( ::Login(url, m_stLoginReq, m_stLoginResp) )
	{
#ifdef _DEBUG
	OutputDebugString("¼ɹ\n");
#endif
		Global::WriteTextLog("¼ɹ");
		m_bLogin = TRUE;
		return true;
	}

#ifdef _DEBUG
	OutputDebugString("¼ʧ\n");
#endif
	Global::WriteTextLog("¼ʧ");

	return false;
}

bool CSATExecutor::Logout(std::string user, std::string password)
{
	return Login(user, password, false);
}

bool CSATExecutor::UpdateDevice()
{
	SATParameters::STDevice stDevice;
	stDevice.strStatus = "0";	// 0ʾ豸; 1ʾ豸æµ
	stDevice.strDeviceSerial = "192.168.1.119:5555";
	stDevice.strHardwareVersion = "SATHardwareVersion";
	stDevice.strManu = "SATManu";
	stDevice.strDeviceMac = "";
	stDevice.strLastJobStartTime = "";
	stDevice.strLastTimeBreak = "";
	stDevice.strComments = "";
	stDevice.strCPU = "";
	stDevice.strSoftwareVersion = "0123456789";
	stDevice.strPhoneNumber = "";
	stDevice.strLastJobFinishTime = "";
	stDevice.strMemory = "";
	stDevice.strModel = "SATModel";
	stDevice.strLastJob = "";
	stDevice.strLastTimeConnected = "2019-12-16 10:16:01";
	stDevice.strElectric = "";

	SATParameters::STUpdateDeviceReq stUpdateDeviceReq;
	SATParameters::STUpdateDeviceResp stUpdateDeviceResp;
	std::string url = Global::g_stSATConfig.szExecuteServer;
	url.append("/ajaxInteractiveManage!updateDeviceMessage.action");
	
	stUpdateDeviceReq.strStatus = "0";
	stUpdateDeviceReq.strUserName = m_stLoginReq.strUserName;		
	stUpdateDeviceReq.strIP = "10.118.158.175";
	stUpdateDeviceReq.strStorage = "228092536KB";
	stUpdateDeviceReq.strRunnerName = "SAT-Admin";
	//stUpdateDeviceReq.strMAC = "40:16:7e:23:10:53";
	if ( Global::g_vtMac.size() )
		stUpdateDeviceReq.strMAC = Global::g_vtMac[0].szMacAddress; // ȡһMACַ;
	else
		stUpdateDeviceReq.strMAC = "";
	stUpdateDeviceReq.strReportType = "1";
	stUpdateDeviceReq.strStartTime = "2019-12-16 19:15:30";
	stUpdateDeviceReq.strMemory = "8938544KB";
	stUpdateDeviceReq.strEndTime = "";
	stUpdateDeviceReq.strCPU = "24.7%";
	stUpdateDeviceReq.devicelist.push_back(stDevice);
	m_vtDevice.push_back(stDevice);
	if ( !::UpdateDeviceMessage(url, stUpdateDeviceReq, stUpdateDeviceResp) )
	{
		return false;
	}
	
	return true;
}

bool CSATExecutor::NotifyTaskStart(SATParameters::STTask* pTask)
{
	if ( !pTask )
		return false;

	SATParameters::STNotifyJobStartReq stNotifyJobStartReq;
	SATParameters::STNotifyJobStartResp stNotifyJobStartResp;
	std::string url = Global::g_stSATConfig.szExecuteServer;
	url.append("/ajaxInteractiveManage!setResult.action");

	TCHAR szValue[36] = {0};
	_itoa_s(pTask->nDeviceId, szValue, 10);
	stNotifyJobStartReq.strDeviceId = szValue;

	_itoa_s(pTask->nExecuteId, szValue, 10);
	stNotifyJobStartReq.strExecuteId = szValue;

	// _itoa_s(stTask.nInstanceId, szValue, 10); // 󵼣ӦʹidnInstanceId
	_itoa_s(pTask->Id, szValue, 10);
	stNotifyJobStartReq.strInstanceId = szValue;					

	//_itoa_s(pTask->nTaskId, szValue, 10);
	stNotifyJobStartReq.strTaskId = pTask->Job.strTaskId;

	stNotifyJobStartReq.strSignalImageUrl = "D:\\\\SAT\\\\Runner\\\\btc_runner_se\\\\runner\\\\output\\\\";//ODF_NPI_RT2841\\\\20191216101613370\\\\192.168.1.119_5555";
	stNotifyJobStartReq.strSignalImageUrl.append(pTask->strTaskName+"\\\\");
	stNotifyJobStartReq.strSignalImageUrl.append(pTask->Job.strUniqueId+"\\\\");
	stNotifyJobStartReq.strSignalImageUrl.append(pTask->Job.strDeviceId);

	if ( SetResult(url, stNotifyJobStartReq, stNotifyJobStartResp) )
	{
		// ˴Ҫ豸Ϊæµ״̬;
		// SetDeviceStatus(BUSY);
		return true;
	}

#ifdef _DEBUG
	OutputDebugString("֪ͨSATʧ\n");
#endif

	return false;
}

bool CSATExecutor::UploadCaseImg(SATParameters::STTask* pTask, SATParameters::STCase *pCase, std::string img)
{
	TCHAR szValue[MAX_PATH] = {0};
	std::string url = Global::g_stSATConfig.szExecuteServer;
	url.append("/ajaxInteractiveManage!saveResultImg.action");

	SATParameters::STSaveImgReq stSaveImgReq;
	SATParameters::STSaveImgResp stSaveImgResp;

	stSaveImgReq.strCaseId = pCase->strId;
	stSaveImgReq.strCaseRepeat = "0";
	_itoa_s(pCase->_nCaseStep, szValue, 10);
	stSaveImgReq.strCaseStep = szValue;
	// ʵId;
	_itoa_s(pTask->nDeviceId, szValue, 10);
	stSaveImgReq.strDeviceId = szValue;//pTask->Job.strDeviceId;
	// TaskеExecuteId
	_itoa_s(pTask->nExecuteId, szValue, 10);
	stSaveImgReq.strExecuteId = szValue;
	// ʵId;
	_itoa_s(pTask->nInstanceId, szValue, 10);
	stSaveImgReq.strInstanceId = szValue;
	stSaveImgReq.strJobRepeat = "0";
	// עܿӣroundnum븳ֵ01;
	stSaveImgReq.strRoundNum = "0";
	stSaveImgReq.strTaskType = pTask->strTaskType;
	stSaveImgReq.strUploads = img;

	// ϴͼƬ;
	if ( SaveResultImg(url, stSaveImgReq, stSaveImgResp) )
	{
		return true;
	}

	return false;
}

bool CSATExecutor::UploadCaseLog(SATParameters::STTask* pTask, SATParameters::STCase *pCase)
{
	TCHAR szValue[MAX_PATH] = {0};
	std::string url = Global::g_stSATConfig.szExecuteServer;
	url.append("/ajaxInteractiveManage!saveCaseOrTaskLog.action");

	SATParameters::STSaveLogReq stSaveLogReq;
	SATParameters::STSaveLogResp stSaveLogResp;

	stSaveLogReq.strCaseId = pCase->strId;
	// ִID;
	_itoa_s(pTask->nExecuteId, szValue, 10);
	stSaveLogReq.strExecuteId = szValue;
	stSaveLogReq.strFileType = "caseLogFile";
	// Id;
	//_itoa_s(pTask->nTaskId, szValue, 10);
	stSaveLogReq.strTaskId = pTask->Job.strTaskInstanceId;
	stSaveLogReq.strUserId = pTask->Job.strUserId;
	// Ҫϴ־ļ;
	stSaveLogReq.strUploads = pCase->_strCaseLog;
	if ( SaveCaseOrTaskLog(url, stSaveLogReq, stSaveLogResp) )
	{
		return true;
	}

	return false;
}

bool CSATExecutor::ReportCaseItemFinish(SATParameters::STTask* pTask, SATParameters::STCase *pCase, STCaseItem &caseItem)
{
	TCHAR szValue[MAX_PATH] = {0};
	std::string url = Global::g_stSATConfig.szExecuteServer;
	url.append("/ajaxInteractiveManage!setResultList.action");

	SATParameters::STJobProcessReq stJobProcessReq;
	SATParameters::STJobProcessResp stJobProcessResp;

	stJobProcessReq.strResultState = caseItem.result ? "1" : "0";
	stJobProcessReq.strCaseScene = "";
	// ;
	_itoa_s(pCase->_nCaseStep, szValue, 10);
	stJobProcessReq.strCaseStep = szValue;
	stJobProcessReq.strApkMD5 = "";
	stJobProcessReq.strCrashTime = "";
	// TaskеExecuteId
	_itoa_s(pTask->nExecuteId, szValue, 10);
	stJobProcessReq.strRunnerId = szValue;
	stJobProcessReq.strCPUInfo = "0";
	stJobProcessReq.strRunnedActionNameList = "";
	stJobProcessReq.strArtificialResult = "";
	stJobProcessReq.strArtificialModify = "";
	stJobProcessReq.strRunnerName = "";
	stJobProcessReq.strTaskType = "FUNCTIONALITY";
	stJobProcessReq.strCaseRepeat = "0";
	stJobProcessReq.strApplicationGroup = "";
	// ʵId;
	_itoa_s(pTask->Id, szValue, 10);
	stJobProcessReq.strInstanceId = szValue;
	stJobProcessReq.strCaseId = pCase->strId;
	// ;
	_itoa_s(100*(atoi(pCase->strIndex.c_str()))/pTask->Job.vtCases.size(), szValue, 10);
	stJobProcessReq.strProgress = szValue;
	// Ҫutf-8תgbk;
	stJobProcessReq.strReusltMessage = caseItem.name;//CharEncoding::UTF82ASCII(caseItem.name.c_str());
	stJobProcessReq.strJobRepeat = "0";
	stJobProcessReq.strScreenShot = "";
	stJobProcessReq.strStartTime = pCase->_strStartTime;
	stJobProcessReq.strCrashNumber = "";
	stJobProcessReq.strCaseName = pCase->strCaseName;
	//stJobProcessReq.strFailedReason = CharEncoding::UTF82ASCII(caseItem.remark.c_str());
	//stJobProcessReq.strFailedReason = (char*)CharEncoding::UTF82UNICODE(caseItem.remark.c_str());
	stJobProcessReq.strFailedReason = caseItem.remark;
	for (std::vector<std::string>::iterator it = caseItem.imgs.begin(); it != caseItem.imgs.end(); it++ )
	{
		int npos = it->find_last_of('/');
		if ( std::string::npos != npos )
		{
			stJobProcessReq.strImgName.append(it->substr(npos+1));
			stJobProcessReq.strImgName.append("&");
		}
	}
	if ( stJobProcessReq.strImgName.size() && stJobProcessReq.strImgName.at(stJobProcessReq.strImgName.size()-1) == '&')
		stJobProcessReq.strImgName.erase(stJobProcessReq.strImgName.size()-1);
	stJobProcessReq.strCaseIndex = pCase->strIndex;
	// ʵId;
	_itoa_s(pTask->nDeviceId, szValue, 10);
	stJobProcessReq.strDeviceId = szValue;
	stJobProcessReq.strSceneIndex = "0";
	// ʵId;
	//_itoa_s(pTask->nTaskId, szValue, 10);
	stJobProcessReq.strTaskId = pTask->Job.strTaskId;
	//stJobProcessReq.strAnalysis = CharEncoding::UTF82ASCII(caseItem.data.c_str());
	stJobProcessReq.strAnalysis = caseItem.data.c_str(); 
	// 豸ƣDeviceSerial;
	stJobProcessReq.strDevnceName = pTask->Job.strDeviceId;	// 䲻Χ,һdeviceiddeviceserial,һid;
	// ̶ΪTOTAL
	stJobProcessReq.strInfoType = "";
	// Android豸,Ҫͨadbȡ;
	//stJobProcessReq.strMemoryInfo = stDevice.strMemory;
	stJobProcessReq.strEndTime = CTime::GetCurrentTime().Format(_T("%Y-%m-%d %H:%M:%S"));//"2019-12-16 10:18:20";
	stJobProcessReq.strRoundNumber = "1";
	stJobProcessReq.strResultType = "4";		// reportActionFinish;
	stJobProcessReq.strOperationStep = "";

	if ( SetResultList(url, stJobProcessReq, stJobProcessResp) )
	{
		// ϴͼƬ;
		std::string img;
		for (std::vector<std::string>::iterator it = caseItem.imgs.begin(); it != caseItem.imgs.end(); it++ )
		{
			img = "D:/SAT/results/";
			img.append(it->substr(3));
			UploadCaseImg(pTask, pCase, img);
		}

		return true;
	}

	return false;
}

bool CSATExecutor::ReportCaseFinish(SATParameters::STTask* pTask, SATParameters::STCase *pCase)
{
	TCHAR szValue[MAX_PATH] = {0};
	std::string url = Global::g_stSATConfig.szExecuteServer;
	url.append("/ajaxInteractiveManage!setResultList.action");

	SATParameters::STJobProcessReq stJobProcessReq;
	SATParameters::STJobProcessResp stJobProcessResp;

	// ϱ0ʾűɹִ,	1ʾűʱ;
	if ( pCase->_nExecutionState == 2 )
		stJobProcessReq.strResultState = "0";	// űδִ;
	else if ( pCase->_nExecutionState == 1 )	
		stJobProcessReq.strResultState = "1";	// űִ,Ϊfail;
	
	stJobProcessReq.strCaseScene = "";
	// ;
	_itoa_s(pCase->_nCaseStep, szValue, 10);
	stJobProcessReq.strCaseStep = szValue;
	stJobProcessReq.strApkMD5 = "";
	stJobProcessReq.strCrashTime = "";
	// TaskеExecuteId
	_itoa_s(pTask->nExecuteId, szValue, 10);
	stJobProcessReq.strRunnerId = szValue;
	stJobProcessReq.strCPUInfo = "0";
	stJobProcessReq.strRunnedActionNameList = "";
	stJobProcessReq.strArtificialResult = "";
	stJobProcessReq.strArtificialModify = "";
	stJobProcessReq.strRunnerName = "";
	stJobProcessReq.strTaskType = "FUNCTIONALITY";
	stJobProcessReq.strCaseRepeat = "";
	stJobProcessReq.strApplicationGroup = "";
	// ʵId;עܿ;
	_itoa_s(pTask->Id, szValue, 10);
	stJobProcessReq.strInstanceId = szValue;
	stJobProcessReq.strCaseId = pCase->strId;
	// (###Ҫ޸Ĵ˴###);
	_itoa_s(100*(atoi(pCase->strIndex.c_str()))/pTask->Job.vtCases.size(), szValue, 10);
	stJobProcessReq.strProgress = szValue;
	// Ҫutf-8תgbk;
	stJobProcessReq.strReusltMessage = CharEncoding::ASCII2UTF8("");
	stJobProcessReq.strJobRepeat = "";
	stJobProcessReq.strScreenShot = "";
	stJobProcessReq.strStartTime = pCase->_strStartTime;
	stJobProcessReq.strCrashNumber = "";
	stJobProcessReq.strCaseName = pCase->strCaseName;
	stJobProcessReq.strFailedReason = "";

	stJobProcessReq.strImgName = "";
	stJobProcessReq.strCaseIndex = pCase->strIndex;
	// ʵId;
	_itoa_s(pTask->nDeviceId, szValue, 10);
	stJobProcessReq.strDeviceId = szValue;
	stJobProcessReq.strSceneIndex = "0";
	// ʵId;
	//_itoa_s(pTask->nTaskId, szValue, 10);
	stJobProcessReq.strTaskId = pTask->Job.strTaskId;
	stJobProcessReq.strAnalysis = "";
	// 豸ƣDeviceSerial;
	stJobProcessReq.strDevnceName = pTask->Job.strDeviceId;	// 䲻Χ,һdeviceiddeviceserial,һid;
	// ̶ΪTOTAL
	stJobProcessReq.strInfoType = "TOTAL";
	// Android豸,Ҫͨadbȡ;
	//stJobProcessReq.strMemoryInfo = stDevice.strMemory;
	stJobProcessReq.strEndTime = pCase->_strEndTime;//CTime::GetCurrentTime().Format(_T("%Y-%m-%d %H:%M:%S"));//"2019-12-16 10:18:20";
	stJobProcessReq.strRoundNumber = "1";
	stJobProcessReq.strResultType = "5";		// reportCaseFinish;
	stJobProcessReq.strOperationStep = "";

	if ( SetResultList(url, stJobProcessReq, stJobProcessResp) )
	{
		return true;
	}

	return false;
}

bool CSATExecutor::ReportCaseResult(SATParameters::STTask* pTask, SATParameters::STCase *pCase)
{
	// ȡxmlļ;
	std::string xmlpath = "D:\\SAT\\results\\detail\\";
	xmlpath.append(pCase->_strFileName);
	xmlpath.append("_result.xml");
	std::vector<STCaseItem> vtCaseItem;
	GetCaseXMLResult(xmlpath, vtCaseItem);
	if ( vtCaseItem.size() == 0 )
		return false;
	
	int nIndex = 1;
	TCHAR szValue[MAX_PATH] = {0};
	std::string url = Global::g_stSATConfig.szExecuteServer;
	url.append("/ajaxInteractiveManage!setResultList.action");
	SATParameters::STJobProcessReq stJobProcessReq;
	SATParameters::STJobProcessResp stJobProcessResp;
	// ;
	std::vector<STCaseItem>::iterator it = vtCaseItem.begin();
	for (; it != vtCaseItem.end(); it++ )
	{
		// ϱ(Ƭ);
		ReportCaseItemFinish(pTask, pCase, *it);		
	}

	// ϱ;
	ReportCaseFinish(pTask, pCase);

	// ϴ־;
	UploadCaseLog(pTask, pCase);

	return true;
}

bool CSATExecutor::UploadTaskLog(SATParameters::STTask* pTask)
{
	TCHAR szValue[MAX_PATH] = {0};
	std::string url = Global::g_stSATConfig.szExecuteServer;
	url.append("/ajaxInteractiveManage!saveCaseOrTaskLog.action");

	SATParameters::STSaveLogReq stSaveLogReq;
	SATParameters::STSaveLogResp stSaveLogResp;

	stSaveLogReq.strCaseId = "";
	// ִID;
	_itoa_s(pTask->nExecuteId, szValue, 10);
	stSaveLogReq.strExecuteId = szValue;
	stSaveLogReq.strFileType = "taskLogFile";
	// Id;
	//_itoa_s(pTask->nTaskId, szValue, 10);
	stSaveLogReq.strTaskId = pTask->Job.strTaskInstanceId;
	stSaveLogReq.strUserId = pTask->Job.strUserId;
	// Ҫϴ־ļ;
	stSaveLogReq.strUploads = "D:\\sat\\log.txt";//pTask->_strTaskLog;
	if ( SaveCaseOrTaskLog(url, stSaveLogReq, stSaveLogResp) )
	{
		return true;
	}

	return false;
}

bool CSATExecutor::ReportTaskStart(SATParameters::STTask* pTask)
{
	TCHAR szValue[MAX_PATH] = {0};
	std::string url = Global::g_stSATConfig.szExecuteServer;
	url.append("/ajaxInteractiveManage!setResultList.action");

	SATParameters::STJobProcessReq stJobProcessReq;
	SATParameters::STJobProcessResp stJobProcessResp;

	// Ҫ###
	stJobProcessReq.strResultState = "";	// űִ,Ϊfail;

	stJobProcessReq.strCaseScene = "";
	// ;
	stJobProcessReq.strCaseStep = "0";
	stJobProcessReq.strApkMD5 = "";
	stJobProcessReq.strCrashTime = "";
	// TaskеExecuteId
	_itoa_s(pTask->nExecuteId, szValue, 10);
	stJobProcessReq.strRunnerId = szValue;
	stJobProcessReq.strCPUInfo = "0";
	stJobProcessReq.strRunnedActionNameList = "";
	stJobProcessReq.strArtificialResult = "";
	stJobProcessReq.strArtificialModify = "";
	stJobProcessReq.strRunnerName = "";
	stJobProcessReq.strTaskType = "FUNCTIONALITY";
	stJobProcessReq.strCaseRepeat = "";
	stJobProcessReq.strApplicationGroup = "";
	// ʵId;עܿ;
	_itoa_s(pTask->Id, szValue, 10);
	stJobProcessReq.strInstanceId = szValue;
	stJobProcessReq.strCaseId = "";
	// (###Ҫ޸Ĵ˴###);
	stJobProcessReq.strProgress = "0";
	// Ҫutf-8תgbk;
	stJobProcessReq.strReusltMessage = "ʼ";
	stJobProcessReq.strJobRepeat = "";
	stJobProcessReq.strScreenShot = "";
	stJobProcessReq.strStartTime = pTask->strStartTime;
	stJobProcessReq.strCrashNumber = "";
	stJobProcessReq.strCaseName = "";
	stJobProcessReq.strFailedReason = "";

	stJobProcessReq.strImgName = "";
	stJobProcessReq.strCaseIndex = "";
	// ʵId;
	_itoa_s(pTask->nDeviceId, szValue, 10);
	stJobProcessReq.strDeviceId = szValue;
	stJobProcessReq.strSceneIndex = "";
	// ʵId;
	//_itoa_s(pTask->nTaskId, szValue, 10);
	stJobProcessReq.strTaskId = pTask->Job.strTaskId;
	stJobProcessReq.strAnalysis = "";
	// 豸ƣDeviceSerial;
	stJobProcessReq.strDevnceName = pTask->Job.strDeviceId;	// 䲻Χ,һdeviceiddeviceserial,һid;
	// ̶ΪTOTAL
	stJobProcessReq.strInfoType = "TOTAL";
	// Android豸,Ҫͨadbȡ;
	//stJobProcessReq.strMemoryInfo = stDevice.strMemory;
	stJobProcessReq.strEndTime = "";// CTime::GetCurrentTime().Format(_T("%Y-%m-%d %H:%M:%S"));//"2019-12-16 10:18:20";
	stJobProcessReq.strRoundNumber = "1";
	stJobProcessReq.strResultType = "0";		// reportJobStart;
	stJobProcessReq.strOperationStep = "";

	if ( SetResultList(url, stJobProcessReq, stJobProcessResp) )
	{
		return true;
	}

	return false;
}

bool CSATExecutor::ReportTaskFinish(SATParameters::STTask* pTask)
{
	TCHAR szValue[MAX_PATH] = {0};
	std::string url = Global::g_stSATConfig.szExecuteServer;
	url.append("/ajaxInteractiveManage!setResultList.action");

	SATParameters::STJobProcessReq stJobProcessReq;
	SATParameters::STJobProcessResp stJobProcessResp;

	// Ҫ###
	stJobProcessReq.strResultState = "0";	// űִ,Ϊfail;

	stJobProcessReq.strCaseScene = "";
	// ;
	stJobProcessReq.strCaseStep = "0";
	stJobProcessReq.strApkMD5 = "";
	stJobProcessReq.strCrashTime = "";
	// TaskеExecuteId
	_itoa_s(pTask->nExecuteId, szValue, 10);
	stJobProcessReq.strRunnerId = szValue;
	stJobProcessReq.strCPUInfo = "0";
	stJobProcessReq.strRunnedActionNameList = "";
	stJobProcessReq.strArtificialResult = "";
	stJobProcessReq.strArtificialModify = "";
	stJobProcessReq.strRunnerName = "";
	stJobProcessReq.strTaskType = "FUNCTIONALITY";
	stJobProcessReq.strCaseRepeat = "0";
	stJobProcessReq.strApplicationGroup = "";
	// ʵId;עܿ;
	_itoa_s(pTask->Id, szValue, 10);
	stJobProcessReq.strInstanceId = szValue;
	stJobProcessReq.strCaseId = "";
	// (###Ҫ޸Ĵ˴###);
	stJobProcessReq.strProgress = "100";
	// Ҫutf-8תgbk;
	stJobProcessReq.strReusltMessage = "";
	stJobProcessReq.strJobRepeat = "0";
	stJobProcessReq.strScreenShot = "";
	stJobProcessReq.strStartTime = pTask->strStartTime;
	stJobProcessReq.strCrashNumber = "";
	stJobProcessReq.strCaseName = "";
	stJobProcessReq.strFailedReason = "";

	stJobProcessReq.strImgName = "";
	stJobProcessReq.strCaseIndex = "";
	// ʵId;
	_itoa_s(pTask->nDeviceId, szValue, 10);
	stJobProcessReq.strDeviceId = szValue;
	stJobProcessReq.strSceneIndex = "0";
	// ʵId;
	//_itoa_s(pTask->nTaskId, szValue, 10);
	stJobProcessReq.strTaskId = pTask->Job.strTaskId;
	stJobProcessReq.strAnalysis = "";
	// 豸ƣDeviceSerial;
	stJobProcessReq.strDevnceName = pTask->Job.strDeviceId;	// 䲻Χ,һdeviceiddeviceserial,һid;
	// ̶ΪTOTAL
	stJobProcessReq.strInfoType = "";
	// Android豸,Ҫͨadbȡ;
	//stJobProcessReq.strMemoryInfo = stDevice.strMemory;
	stJobProcessReq.strEndTime = CTime::GetCurrentTime().Format(_T("%Y-%m-%d %H:%M:%S"));//"2019-12-16 10:18:20";
	stJobProcessReq.strRoundNumber = "1";
	stJobProcessReq.strResultType = "1";		// reportJobFinish;
	stJobProcessReq.strOperationStep = "";

	if ( SetResultList(url, stJobProcessReq, stJobProcessResp) )
	{
		return true;
	}

	return false;
}

bool CSATExecutor::GetCaseXMLResult(std::string xmlpath, std::vector<STCaseItem> &vtCaseItem)
{
	// xml;
	tinyxml2::XMLDocument doc;
	if (tinyxml2::XML_SUCCESS != doc.LoadFile(xmlpath.c_str()) )
	{
		return false;
	}

	tinyxml2::XMLElement *pXmlRoot = NULL;
	if ((pXmlRoot = doc.RootElement()) == NULL)
		return false;
	
	if (_tcsicmp(pXmlRoot->Value(), "results") != 0)
		return false;
	
	tinyxml2::XMLElement *pXmlElent = pXmlRoot->FirstChildElement();
	while (pXmlElent)
	{
		if (_tcsicmp(pXmlElent->Value(), _T("item")) == 0)
		{
			STCaseItem cItem;
			tinyxml2::XMLElement *pItem = pXmlElent->FirstChildElement();
			while (pItem)
			{
				if (_tcsicmp(pItem->Value(), _T("name")) == 0)
				{
					cItem.name = pItem->GetText();
				}
				else if (_tcsicmp(pItem->Value(), _T("result")) == 0)
				{
					cItem.result = pItem->BoolText();
				}
				else if (_tcsicmp(pItem->Value(), _T("data")) == 0)
				{
					cItem.data = pItem->GetText();
				}
				else if (_tcsicmp(pItem->Value(), _T("log")) == 0)
				{
					cItem.log = pItem->GetText();
				}
				else if (_tcsicmp(pItem->Value(), _T("remark")) == 0)
				{
					cItem.remark = pItem->GetText();
				}
				else if (_tcsicmp(pItem->Value(), _T("screen")) == 0)
				{
					cItem.imgs.push_back(pItem->GetText());
				}

				pItem = pItem->NextSiblingElement();
			}

			// ѹ;
			if ( cItem.name.size() )
				vtCaseItem.push_back(cItem);
		}

		pXmlElent = pXmlElent->NextSiblingElement();
	}
	
	return true;
}

void CSATExecutor::StartWork()
{
	m_hEventHearbeat = CreateEvent(NULL, TRUE, FALSE, NULL);
	if ( m_hEventHearbeat == NULL )
	{
		_tprintf_s(_T("¼ʧ\n"));
		return;
	}

	m_hEventExcuteScript = CreateEvent(NULL, TRUE, FALSE, NULL);
	if ( m_hEventExcuteScript == NULL )
	{
		_tprintf_s(_T("¼ʧ2\n"));
		return;
	}

	m_hThreadHearbeat = CreateThread(NULL, 0, HearbeatThread, this, 0, NULL);
	if ( m_hThreadHearbeat == NULL)
	{
		SetEvent(m_hEventHearbeat);
		SetEvent(m_hEventExcuteScript);
		CloseHandle(m_hEventHearbeat);
		CloseHandle(m_hEventExcuteScript);
		m_hEventHearbeat = NULL;
		m_hEventExcuteScript = NULL;
		_tprintf_s(_T("߳ʧ\n"));
		return;
	}

	m_hThreadExcuteScript = CreateThread(NULL, 0, ExecuteScriptThread, this, 0, NULL);
	if ( m_hThreadExcuteScript == NULL )
	{
		SetEvent(m_hEventHearbeat);
		SetEvent(m_hEventExcuteScript);
		CloseHandle(m_hEventHearbeat);
		CloseHandle(m_hEventExcuteScript);
		m_hEventHearbeat = NULL;
		m_hEventExcuteScript = NULL;
		WaitForSingleObject(m_hThreadHearbeat,INFINITE);
		if (m_hThreadHearbeat)
			CloseHandle(m_hThreadHearbeat);
		m_hThreadHearbeat = NULL;
		_tprintf_s(_T("߳ʧ2\n"));
		return;
	}
}

void CSATExecutor::EndofWork()
{

}

DWORD CSATExecutor::HearbeatThread(LPVOID lpVoid)
{
	CSATExecutor *that = (CSATExecutor*)lpVoid;
	if ( !that ) return 0;
	
	do {
		// ûе¼ɹ,ѯ;
		if ( !that->m_bLogin ) continue;
		
		SATParameters::STHeartbeatReq stHeartbeatReq;
		SATParameters::STHeartbeatResp stHeartbeatResp;
		std::string url = Global::g_stSATConfig.szExecuteServer;
		url.append("/ajaxInteractiveManage!executeHeartbeat.action");

		stHeartbeatReq.strUserName = that->m_stLoginReq.strUserName;
		stHeartbeatReq.strRunnerMac = that->m_stLoginReq.strMAC;
		stHeartbeatReq.devicelist.assign(that->m_vtDevice.begin(), that->m_vtDevice.end());
		if ( Heartbeat(url, stHeartbeatReq, stHeartbeatResp) ) {
#ifdef _DEBUG
			OutputDebugString("ѯɹ\n");
#endif
			Global::WriteTextLog("ѯɹ");
			std::vector<SATParameters::STTask>::iterator it = stHeartbeatResp.vtTask.begin();
			for ( ; it != stHeartbeatResp.vtTask.end(); it++ ) {
				if (!that->IsTaskExist(*it)) {
					// ѹ;
					AutoThreadSection ats(&that->m_csTask);
					// ͬʱ;
					std::string host = Global::g_stSATConfig.szCaseServer;
					std::string url = host + "/ajaxInteractiveManage!getCaseFileListUrl.action";
					std::vector<SATParameters::STCase>::iterator _case = it->Job.vtCases.begin();
					for ( int i = 1; _case != it->Job.vtCases.end(); _case++) {
						_case->_nCaseStep = i++;
						SATParameters::STScriptUrlResp stScriptUrlResp;
						if ( DownloadScript(url, _case->strId, Global::g_stSATConfig.szScriptDir, stScriptUrlResp) ) {
							_case->_strFileDir = stScriptUrlResp._strFileDir;
							_case->_strFileName = stScriptUrlResp._strFileName;
							_case->_strScriptPath = stScriptUrlResp._strScripFile;
						}
#ifdef _DEBUG
						else
						{
							OutputDebugString("ؽűʧ\n");
						}
#endif
					}

					that->m_vtTask.push_back(*it);

					// ֪ͨSAT,űʼִ;
					// ͬʱ洢ݿ;
					/*
					db process
					*/
				}
			}
		}

	} while ( WaitForSingleObject(that->m_hEventHearbeat, 5000) == WAIT_TIMEOUT );

	return 0;
}

DWORD CSATExecutor::ExecuteScriptThread(LPVOID lpVoid)
{
	CSATExecutor *that = (CSATExecutor*)lpVoid;
	if ( !that ) return 0;

	do {
		// Ƿִ;
		SATParameters::STTask *pTask = that->IsThereATaskInProcess();
		if ( pTask ) {// ִ;
			if ( pTask->_bConcurrent ) {// ;

			}
			else {// ;
				// Ƿнűִ;
				SATParameters::STCase* pCase = that->IsCaseScriptProcess(pTask->Job.vtCases);
				if ( pCase ) {
					CScriptExecutor *pExcutor = (CScriptExecutor*)pCase->_pExcutor;
					if ( pExcutor ) {
						if ( pExcutor->IsScriptOver() ) {
							pCase->_nExecutionState = 2;
							// ϱ,ɽű,ϴ;
							that->ReportCaseResult(pTask, pCase);
						}
						else {
							// жǷʱ;
							ULONGLONG ulCurTickCount = GetTickCount64();
							if ( ulCurTickCount - pExcutor->GetActiveTickCount() > 1800000) {	
								// ʱж;
								pCase->_nExecutionState = 3;
								// ϱ;
								that->ReportCaseResult(pTask, pCase);
							}
						}
					}
				}
				else {
					// ûִе,ʼִµ;
					pCase = that->ExecuteFreeCaseScript(pTask);
					if ( NULL == pCase ) {
						// ûпеִ,˵ִ;
						pTask->_nExecutionState = 2;
						// ϱ;
						that->ReportTaskFinish(pTask);
						// ϱ;
						that->UploadTaskLog(pTask);
					}
				}
			}
		}
		else {
			// ȡе;
			pTask = that->GetFreeTask();
			if ( pTask ) {
				// Ƿֲ֧;
				if ( pTask->_bConcurrent ) {
					// ʱȫһ𲢷;
					std::vector<SATParameters::STCase>::iterator _case = pTask->Job.vtCases.begin();
					for ( ; _case != pTask->Job.vtCases.end(); _case++) {
						if (!_case->_pExcutor) {					
							CScriptExecutor *pExcutor = new CScriptExecutor();
							if ( pExcutor ) {
								_case->_pExcutor = pExcutor;
								pExcutor->InitScript(_case->_strScriptPath, _case->_strFileDir + "\\" + _case->_strFileName + ".txt", "", SUBPROCESS);
								pExcutor->StartScript();
								// ִ;
								_case->_nExecutionState = 1;
							}
						}
					}

					// Ϊִ;
					pTask->_nExecutionState = 1;
				}
				else {
					// Ƿűִ;
					SATParameters::STCase* pCase = that->IsCaseScriptProcess(pTask->Job.vtCases);
					if ( !pCase ) {
						// ִпű;
						that->ExecuteFreeCaseScript(pTask);
					}				
				}

				// ֪ͨSAT,űʼִ;
				that->NotifyTaskStart(pTask);

				// ֪ͨSAT,űʼ;
				that->ReportTaskStart(pTask);
			}	
#ifdef _DEBUG
			else
			{
				OutputDebugString("ִ\n");
			}
#endif
		}
	} while ( WaitForSingleObject(that->m_hEventExcuteScript, 10000) == WAIT_TIMEOUT );

	return 0;
}