#ifndef __SAT_EXECUTOR__
#define __SAT_EXECUTOR__

#pragma once

#include "CritSection.h"

// xml;
typedef struct __ST_CASEITEM__
{
	bool result;
	std::string name;
	std::string data;
	std::vector<std::string> imgs;
	std::string log;
	std::string remark;
}STCaseItem, *pSTCaseItem;

class CSATExecutor
{
	CSATExecutor(void);
public:
	// ģʽ;
	static CSATExecutor* GetInstance()
	{
		static CSATExecutor* pInstance = NULL;
		if ( pInstance == NULL )
		{
			pInstance = new CSATExecutor;
		}

		return pInstance;
	}

	~CSATExecutor(void);

protected:
	// ߳̿ƾ;
	HANDLE  m_hEventHearbeat;
	// ߳̾;
	HANDLE	m_hThreadHearbeat;
	// ߳̿ƾ;
	HANDLE  m_hEventExcuteScript;
	// ִ߳̾;
	HANDLE	m_hThreadExcuteScript;

	// Ƿ¼ɹ;
	BOOL	m_bLogin;

	ThreadSection	m_csTask;
	std::list<SATParameters::STTask> m_vtTask;
	std::vector<SATParameters::STDevice> m_vtDevice;
	SATParameters::STLoginReq	m_stLoginReq;
	SATParameters::STLoginResp	m_stLoginResp;
	// ִ;
	std::string m_strActuatorName;

	// Ƿ;
	bool IsTaskExist(SATParameters::STTask &task);
	// Ƿִ;
	SATParameters::STTask* IsThereATaskInProcess();
	// ȡδִе;
	SATParameters::STTask* GetFreeTask();
	// Ƿűִ;
	SATParameters::STCase* IsCaseScriptProcess(std::vector<SATParameters::STCase> &vtCases);
	// ȡδִе;
	SATParameters::STCase* GetFreeCaseScript(std::vector<SATParameters::STCase> &vtCases);

	// ִп;
	SATParameters::STCase* ExecuteFreeCaseScript(SATParameters::STTask* pTask);
public:
	// ¼;
	bool Login(std::string user, std::string password, std::string actuator, bool bLogin = true);
	// ǳ;
	bool Logout(std::string user, std::string password);
	const SATParameters::STLoginResp *GetLoginResp() const{ return &m_stLoginResp;};
	// ִ;
	void SetActuatorName(const char *pszActuator){ if (pszActuator) m_strActuatorName = pszActuator;};
	// 豸Ϣ;
	bool UpdateDevice();
	// ֪ͨSATʼ;
	bool NotifyTaskStart(SATParameters::STTask* pTask);
	// ϴͼƬ;
	bool UploadCaseImg(SATParameters::STTask* pTask, SATParameters::STCase *pCase, std::string img);
	// ϴ;
	bool UploadCaseLog(SATParameters::STTask* pTask, SATParameters::STCase *pCase);
	// ϱ;
	bool ReportCaseItemFinish(SATParameters::STTask* pTask, SATParameters::STCase *pCase, STCaseItem &caseItem);
	// ϱ;
	bool ReportCaseFinish(SATParameters::STTask* pTask, SATParameters::STCase *pCase);
	// ϱ;
	bool ReportCaseResult(SATParameters::STTask* pTask, SATParameters::STCase *pCase);
	// ϴ;
	bool UploadTaskLog(SATParameters::STTask* pTask);
	// ϱʼ;
	bool ReportTaskStart(SATParameters::STTask* pTask);
	// ϱ;
	bool ReportTaskFinish(SATParameters::STTask* pTask);
	// ȡxml;
	bool GetCaseXMLResult(std::string xmlpath, std::vector<STCaseItem> &vtCaseItem);
	// ӿ;
public:
	// ʼ;	
	void StartWork();
	// ;
	void EndofWork();

	// dbм;
	void LoadTaskInfo();
	// ߳;
	static DWORD WINAPI HearbeatThread(LPVOID lpVoid);
	// ִ߳;
	static DWORD WINAPI ExecuteScriptThread(LPVOID lpVoid);
};


#endif //__SAT_EXECUTOR__