#ifndef __OTA_20190702__
#define __OTA_20190702__

#include "SynSerial.h"
#include <list>

#define CMD_SIZE 55
#define BUFFER_LEN 10240
#pragma once

typedef struct __SIACP__
{
	std::string name; // ;
	std::string head; // ͷ;
	std::string code; // ;
	std::string mark; // ;
	bool bMulticode ;	// Ƿ;
	int cmd_wait_time ;	// ָʱ;
	int read_wait_time ;	// д괮ں󣬵ȴö;
} _SIACP_, *_pSIACP_;


// ͷ루룩
enum PHeader {
	TV_Debug = 0xAA,
	TV_Return = 0xAB,
	TV_Panel_Debug = 0xAC,
	TV_Panel_Return = 0xAD,
	TV_Debug_Other = 0xAE,
	TV_Other_Return = 0xAF,
};

// ;
enum RCode {
	RC_OK = 0x0A,      // ִͨ;
	RC_ERR = 0x0E,     // ޷ִ;
	RC_LOSE = 0x0F,    // ʧ·;
};

//////////////////////////////////////////////////////////////////////////
enum LOG_ENUM
{
	NORMAL_LOG = 0,
	ERROR_LOG,
	OK_LOG,
	INFO_LOG
};

extern std::string HexString2Bytes(std::string strHex, const int& len /* = 3 */);
extern std::string Bytes2HexString(const unsigned char* pbuffer, int nLen);
extern std::string Bytes2HexString(const unsigned char* pbuffer, int nLen, char chSpace);

class CSIACP
{
public:
	CSIACP(void);
	~CSIACP(void);

	void SetMainDlg(void* p);
	void ShowMessage(LPCTSTR lpMsg, LOG_ENUM logtype = NORMAL_LOG);
protected:
	CSynSerial* m_pSerial;
	void* m_pMainDlg;
	typedef struct __RTN__
	{
		int len;			// صݳ;
		std::string data;	// ص;	

		__RTN__()
		{
			len = 0;	
		}
	}RTN, * pRTN;

	std::vector<RTN> m_vtdata;
	std::vector<_SIACP_> m_vtcommand;
	BOOL ExecSerialCommand(const _SIACP_& siacp, std::string command);
	BOOL ParserSerialData(std::vector<RTN>& vtdata, const _SIACP_& siacp, byte* pbuffer, DWORD dwlen);

	const _SIACP_* GetSiacp(std::string name);
	std::string GetSiacpCommand(const _SIACP_& siacp, std::string others, int othersLen);
	std::string GetSiacpCommand(std::string name, std::string others, int othersLen);

public:
	void LoadCommand();
	void SaveCommand(std::vector<_SIACP_> &vtSiacp, std::string path);
	void SaveCommand(_SIACP_ (&Siacp)[CMD_SIZE], std::string path);
	BOOL OpenComm(int nSerialPort, DWORD dwBaudrate);
	void CloseComm();
	BOOL IsOpen() {
		return m_pSerial && m_pSerial->IsOpen();
	}
	BOOL SendCommand(std::string cmd_name, const byte* pszOthers = NULL, DWORD dwOthersLen = 0);
	BOOL SendCommand2(std::string cmd_name, std::string data = "", size_t nlen = 0);
public:
	// ȴtvɹ;
	BOOL SCBC_WaitTVBoot();
	BOOL SCBC_MTKInit();
	// 빤ģʽ;
	BOOL SCBC_EnterFactory();
	// 뿪ģʽ;
	BOOL SCBC_LeaveFactory();
	// ʼWb;
	BOOL SCBC_WBInit();
	// ȡpid;
	BOOL SCBC_GetProjectId(int& pid);
	// 汾;
	BOOL SCBC_GetSoftVersion(std::string& strVer);
	// 豸ID
	BOOL SCBC_GetDeviceId(std::string& strDid);
	// ClientType;
	BOOL SCBC_GetClientType(std::string& strClt);
	// MACַ;
	BOOL SCBC_GetMAC(std::string& strMac);
	// HDCP Key;
	BOOL SCBC_GetHDCPKey(std::string& strHDCP);
	// HDCP Key2.2;
	BOOL SCBC_GetHDCPKey22(std::string& strHDCP22);
	// Widi;
	BOOL SCBC_GetWidi(std::string& strWidi);
	// Netflix ESN;
	BOOL SCBC_GetNetflixESN(std::string& strESN);
	// Widevine;
	BOOL SCBC_GetWidevine(std::string& strWidevine);
	// ci plus key;
	BOOL SCBC_GetCiKey(std::string& strCikey);
	// OSD Language;
	BOOL SCBC_GetOSDLanguage(std::string& strOSDLan);
	// Shop Language;
	BOOL SCBC_GetShopLanguage(std::string& strShopLan);
	BOOL SCBC_GetChannel(std::string& channel);

	BOOL SCBC_SetProjectId(const int& pid);
	BOOL SCBC_SetProjectId(std::string pid);
	BOOL SCBC_SetProjectId(const byte* pBuffer, const int& nLen);
	BOOL SCBC_SetDeviceId(std::string strDeviceId);
	BOOL SCBC_SetDeviceId(const byte* pBuffer, const int &nLen);
	BOOL SCBC_SetMAC(std::string strMac);
	BOOL SCBC_SetMAC(const byte* pBuffer, const int& nLen);
	BOOL SCBC_SetHDCPKey(std::string strHDCP, BOOL bHasSpace = FALSE);
	BOOL SCBC_SetHDCPKey(const byte* pBuffer, const int& nLen);
	BOOL SCBC_SetHDCPKey22(std::string strHDCP22, BOOL bHasSpace = FALSE);
	BOOL SCBC_SetHDCPKey22(const byte* pBuffer, const int& nLen);
	BOOL SCBC_SetNetflixESN(std::string strESN, BOOL bHasSpace = FALSE);
	BOOL SCBC_SetNetflixESN(const byte* pBuffer, const int& nLen);
	BOOL SCBC_SetWidi(std::string strWidi, BOOL bHasSpace = FALSE);
	BOOL SCBC_SetWidi(const byte* pBuffer, const int& nLen);
	BOOL SCBC_SetWidevine(std::string strWidevine, BOOL bHasSpace = FALSE);
	BOOL SCBC_SetWidevine(const byte* pBuffer, const int& nLen);
	BOOL SCBC_SetCiKey(std::string strCiKey, BOOL bHasSpace = FALSE);
	BOOL SCBC_SetCiKey(const byte* pBuffer, const int& nLen);
	BOOL SCBC_SetOSDLanguage(std::string lan, BOOL bHasSpace = TRUE);
	BOOL SCBC_SetOSDLanguage(const byte* pBuffer, const int& nLen);
	BOOL SCBC_SetShopLanguage(std::string lan, BOOL bHasSpace = TRUE);
	BOOL SCBC_SetShopLanguage(const byte* pBuffer, const int& nLen);
	BOOL SCBC_SetChannel(std::string channel, BOOL bHasSpace = TRUE);
	BOOL SCBC_SetChannel(const byte* pBuffer, const int& nLen);
	BOOL SCBC_SetChannel(int channel);
	BOOL SCBC_SetWBNormal(std::string data);
	BOOL SCBC_SetWBNormal(const byte* pBuffer, const int& nLen);
	BOOL SCBC_SetWBCool(std::string data);
	BOOL SCBC_SetWBCool(const byte* pBuffer, const int& nLen);
	BOOL SCBC_SetWBWarm(std::string data);
	BOOL SCBC_SetWBWarm(const byte* pBuffer, const int& nLen);

	BOOL SCBC_CheckDeviceId();
	BOOL SCBC_CheckMAC();
	BOOL SCBC_CheckHDCP();
	BOOL SCBC_CheckHDCP22();
	BOOL SCBC_CheckNetflixESN();
	BOOL SCBC_CheckWidi();
	BOOL SCBC_CheckWidevine();
	BOOL SCBC_CheckCikey();
	
	BOOL SCBC_StarWarmUpMode();
	BOOL SCBC_StopWarmUpMode();
	// ˵ʾ;
	BOOL SCBC_ShowFactoryMenu();
	BOOL SCBC_HideFactoryMenu();
	// Ϣʾ;
	BOOL SCBC_ShowFactoryInformation();
	BOOL SCBC_HideFactoryInformation();
	// ϻģʽĿءϻʱȡ;
	BOOL SCBC_EnterAgingModel();
	BOOL SCBC_LeaveAgingModel();
	BOOL SCBC_ReadAgingTime(int &min);
	// ;
	BOOL SCBC_SetRedGainRegister(int value);
	BOOL SCBC_SetGreenGainRegister(int value);
	BOOL SCBC_SetBlueGainRegister(int value);
	// ƫ;
	BOOL SCBC_SetRedOffsetRegister(int value);
	BOOL SCBC_SetGreenOffsetRegister(int value);
	BOOL SCBC_SetBlueOffsetRegister(int value);
};

extern std::string HexString2Bytes(std::string strHex, const int& len = 3);
#endif