﻿
// TCL Tools.cpp: 定义应用程序的类行为。
//

#include "pch.h"
#include "framework.h"
#include "TCL Copy Tool.h"
#include "TCL Copy ToolDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CTCLToolsApp

BEGIN_MESSAGE_MAP(CTCLToolsApp, CWinApp)
	ON_COMMAND(ID_HELP, &CWinApp::OnHelp)
END_MESSAGE_MAP()


// CTCLToolsApp 构造

CTCLToolsApp::CTCLToolsApp()
{
	// 支持重新启动管理器
	m_dwRestartManagerSupportFlags = AFX_RESTART_MANAGER_SUPPORT_RESTART;

	// TODO: 在此处添加构造代码，
	// 将所有重要的初始化放置在 InitInstance 中
}


// 唯一的 CTCLToolsApp 对象

CTCLToolsApp theApp;


// CTCLToolsApp 初始化

BOOL CTCLToolsApp::InitInstance()
{
// TODO: 调用 AfxInitRichEdit2() 以初始化 richedit2 库。\n"	// 如果一个运行在 Windows XP 上的应用程序清单指定要
	// 使用 ComCtl32.dll 版本 6 或更高版本来启用可视化方式，
	//则需要 InitCommonControlsEx()。  否则，将无法创建窗口。
	INITCOMMONCONTROLSEX InitCtrls;
	InitCtrls.dwSize = sizeof(InitCtrls);
	// 将它设置为包括所有要在应用程序中使用的
	// 公共控件类。
	InitCtrls.dwICC = ICC_WIN95_CLASSES;
	InitCommonControlsEx(&InitCtrls);

	AfxInitRichEdit2();
	CWinApp::InitInstance();

#if 1
	// 获取模块的目录;
	TCHAR szDrive[MAX_PATH] = { 0 };
	TCHAR szDir[MAX_PATH] = { 0 };
	TCHAR szExt[MAX_PATH] = { 0 };
	
	::GetModuleFileName(NULL, Global::g_szCurModulePath, sizeof(Global::g_szCurModulePath) / sizeof(TCHAR));
	//_tsplitpath_s(Global::g_szCurModulePath, szDrive, szDir, Global::g_szFna, szExt);
	//_tcscpy_s(Global::g_szCurModuleDir, szDrive);
	//_tcscat_s(Global::g_szCurModuleDir, szDir);
	::GetCurrentDirectory(MAX_PATH, Global::g_szCurModuleDir);
	_tcscat_s(Global::g_szCurModuleDir, _T("\\"));
	// config文件路径;
	_stprintf_s(Global::g_szConfig, _T("%sconfig.ini"), Global::g_szCurModuleDir);

	// 日志模板;
	char szFileName[MAX_PATH];
	sprintf_s(szFileName, "%s\\log4crc.xml", Global::g_szCurModuleDir);
	///设置日志配置文件名
	LOG4C_PARAM_CFG_FILE_NAME(szFileName);
	///设置日志级别
	LOG4C_PARAM_LOG_LEVEL("unknown");
	///设置日志文件大小
	LOG4C_PARAM_LOG_FILE_SIZE(1024*1024*10);
	///设置生成日志文件个数，达到最大个数将自动覆盖最旧的日志
	LOG4C_PARAM_LOG_FILE_NUM(100);
	///设置每次记录日志都重新读取日志配置文件
	LOG4C_PARAM_REREAD_LOG_CFG_FILE(1);
	///带参数日志模块初始化,以上所有设置了的参数都将生效，没有设置的采用缺省值
	LOG4C_INIT_WITH_PARAM();

#if 0 // 等级示例;
	LOG4C((LOG_FATAL, "LOG_FATAL!"));
	LOG4C((LOG_ALERT, "LOG_ALERT!"));
	LOG4C((LOG_CRIT, "LOG_CRIT!"));
	LOG4C((LOG_ERROR, "LOG_ERROR!"));
	LOG4C((LOG_WARN, "LOG_WARN!"));
	LOG4C((LOG_NOTICE, "LOG_NOTICE!"));
	LOG4C((LOG_INFO, "LOG_INFO!"));
	LOG4C((LOG_DEBUG, "LOG_DEBUG!"));
	LOG4C((LOG_TRACE, "LOG_TRACE!"));
	LOG4C((LOG_NOTSET, "LOG_NOTSET!"));
	LOG4C((LOG_UNKNOWN, "LOG_UNKNOWN!"));
#endif

	LOG4C((LOG_NOTICE, "程序开始运行!"));
#endif

	Global::GetConfig();
	Global::GetMacAddress();
	AfxEnableControlContainer();

	if (g_db.Open(Global::g_tConfig.com))
		g_db.RemoveReportInfo();

#ifdef _DEBUG

	auto HexString2Bytes = [](std::string strHex, const int& len /* = 3 */)
	{
		auto TwoHexChar2Char = [](char ch1, char ch2)
		{
			char Numb1;
			char Numb2;

			if (ch1 >= 'A')
				Numb1 = (toupper(ch1) - '0' - 7) * 16;
			else
				Numb1 = (ch1 - '0') * 16;

			if (ch2 >= 'A')
				Numb2 = (toupper(ch2) - '0' - 7);
			else
				Numb2 = (ch2 - '0');

			return (Numb1 + Numb2);
		};

		byte value = 0;
		std::string strBytes;
		int nSize = strHex.size();
		for (int i = 0; i < nSize; i += len)
		{
			strBytes.push_back(TwoHexChar2Char(strHex[i], strHex[i + 1]));
		}

		return strBytes;
	};

	std::vector<CSIACP::RTN> vtdata;
	_SIACP_ siacp = { "GetWidevine", "AA", "EC", "00", true, 100 };
	std::string data = "AB 05 0A DF 4E AB FE 01 0B ED 00 00 00 01 00 01 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 01 4D 53 54 41 52 5F 53 45 43 55 52 45 5F 53 54 4F 52 45 5F 46 49 4C 45 5F 4D 41 47 49 43 5F 49 44 7E EE CC 10 32 C1 0A 83 3B FB A2 46 A2 90 C7 90 8F 04 3B DE AB AD AA 7A 99 A8 B0 24 63 B3 D9 D6 60 23 E5 83 4D 0F 47 32 3C 3D A3 88 72 66 74 12 91 8C A5 10 25 7D B7 D6 7E 1D E0 2B 64 E9 72 13 4D 4C B6 9F BF 71 6C 4C 1B BF E1 F2 0C 51 9E C5 D5 44 9C 6D B4 5A D0 E9 35 A9 BD 93 A6 3D 9D 7E 7D E0 F0 0E 2C 24 12 50 13 CF 9C 44 DD 8D 53 0E 40 FA 4F EE E6 74 2D 9C CF A8 5B BF C3 B6 1B 52 F5 57 22 96 7A 85 CE 3E 05 32 60 33 D8 A1 BD C4 5D 37 C4 D9 E8 63 88 72 4F C0 98 E5 2A 0E 56 30 96 07 D4 FD 90 9C E9 0F 52 49 9E 0E F4 6B 6E 40 30 25 11 80 60 6D D6 5C 9D CD 9D DD 1B BD FF 12 37 DD 05 D6 ED F4";
	std::string bb = HexString2Bytes(data, 3);
	g_siacp.ParserSerialData(vtdata, siacp, (byte*)bb.c_str(), bb.size());
#endif
	// 启动线程上报;
	std::thread t([]() {
		COTA ota;
		BOOL bRet;
		std::string xml;
		std::vector<STReport> vt;
		while (true)
		{
			vt.clear();
			g_db.QueryUnReportInfo(vt);
			for (auto it : vt)
			{
				if ( _tcsicmp("https://cn.ota.qhmoka.com/ota-services/report/reportToolsLog", it.url.c_str()) == 0 )
				{
					bRet = ota.ReportLog(it.url, it.content);
				}
				else
				{
					bRet = ota.GetKeyInfo(it.url, it.content, "", "", xml);
				}

				if (bRet)
				{
					// 上报成功;
					g_db.UpdateKeyReportStatus(it);
				}

				std::this_thread::sleep_for(std::chrono::microseconds(500));
			}
			std::this_thread::sleep_for(std::chrono::seconds(10));
		}
		});
	t.detach();
	//std::string vcode;
	//g_ota.GetVCode("CC-A1-2B-03-09-13", vcode);
	// 创建 shell 管理器，以防对话框包含
	// 任何 shell 树视图控件或 shell 列表视图控件。
	CShellManager *pShellManager = new CShellManager;

	// 激活“Windows Native”视觉管理器，以便在 MFC 控件中启用主题
	CMFCVisualManager::SetDefaultManager(RUNTIME_CLASS(CMFCVisualManagerWindows));

	// 标准初始化
	// 如果未使用这些功能并希望减小
	// 最终可执行文件的大小，则应移除下列
	// 不需要的特定初始化例程
	// 更改用于存储设置的注册表项
	// TODO: 应适当修改该字符串，
	// 例如修改为公司或组织名
	SetRegistryKey(_T("应用程序向导生成的本地应用程序"));

	CTCLCopyToolDlg dlg;
	m_pMainWnd = &dlg;
	INT_PTR nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: 在此放置处理何时用
		//  “确定”来关闭对话框的代码
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: 在此放置处理何时用
		//  “取消”来关闭对话框的代码
	}
	else if (nResponse == -1)
	{
		TRACE(traceAppMsg, 0, "警告: 对话框创建失败，应用程序将意外终止。\n");
		TRACE(traceAppMsg, 0, "警告: 如果您在对话框上使用 MFC 控件，则无法 #define _AFX_NO_MFC_CONTROLS_IN_DIALOGS。\n");
	}

	// 删除上面创建的 shell 管理器。
	if (pShellManager != nullptr)
	{
		delete pShellManager;
	}

#if !defined(_AFXDLL) && !defined(_AFX_NO_MFC_CONTROLS_IN_DIALOGS)
	ControlBarCleanUp();
#endif

	// 由于对话框已关闭，所以将返回 FALSE 以便退出应用程序，
	//  而不是启动应用程序的消息泵。
	return FALSE;
}



int CTCLToolsApp::ExitInstance()
{
	// TODO: 在此添加专用代码和/或调用基类
	g_db.Close();
	g_siacp.CloseComm();
	return CWinApp::ExitInstance();
}
