#include "StdAfx.h"
#include "SDK.h"
#include "CritSection.h"
#include "Global.h"
#include "DataImpl.h"
#include <sys/stat.h>
#include "CharEncoding.h"

ThreadSection g_csTask;
std::list<STMid> CSDK::m_vtMidTask;
std::string CSDK::_host;
#define _GET_JSON_STRING(ptr, name, value) \
	if( cJSON_GetObjectItem(ptr, name) )\
		if ( cJSON_GetObjectItem(ptr, name)->valuestring == NULL)\
			value = "";\
		else\
			value = cJSON_GetObjectItem(ptr, name)->valuestring;\
	else\
		value = "";

#define _GET_JSON_INT(ptr, name, value) \
	if( cJSON_GetObjectItem(ptr, name) )\
	if ( cJSON_GetObjectItem(ptr, name)->valueint == NULL)\
	value = 0;\
		else\
		value = cJSON_GetObjectItem(ptr, name)->valueint;\
	else\
	value = 0;

CSDK::CSDK(void):
m_hDownloadEvent(NULL),
m_hThreadDownload(NULL),
m_hReportEvent(NULL),
m_hThreadReport(NULL)
{
	Global::Init();
	Global::GetMacAddress();
}

CSDK::~CSDK(void)
{
	EndDowloadThread();
	EndReportThread();
}

int CSDK::QueryMidInfo(std::string order)
{
	if ( order.size() == 0 )
		return -1;

	CDataImpl db;
	if ( !db.Open() )
		return -2;

	STMid mid;
	int nRow = db.QueryMidInfo(order.c_str(), mid);
	if ( nRow == -1)
		return -3;

	if ( nRow == 0 )
		return 0;

	if ( nRow == 1)
	{
		if ( _tcsicmp(mid.status.c_str(), "0") == 0 )
			return 1;
		else if ( _tcsicmp(mid.status.c_str(), "1") == 0 )
			return 2;
		else if ( _tcsicmp(mid.status.c_str(), "1") == -1 )
			return 3;
	}

	return -4;
}

int CSDK::DownloadMidData(std::string order)
{
	if ( m_hThreadDownload == NULL )
	{
		m_hDownloadEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
		if ( m_hDownloadEvent == NULL )
		{
			return -1;
		}

		m_hThreadDownload = CreateThread(NULL, 0, ThreadDownload, this, 0, NULL);
		if ( m_hThreadDownload == NULL )
		{
			CloseHandle(m_hDownloadEvent);
			m_hDownloadEvent = NULL;
			return -1;
		}
	}

	int nRet = 0;
	STMid host_mid;
	STMid local_mid;
	// https;
	nRet = GetMidInfo(order, host_mid);
	if ( nRet == -1)
		return -5;
	else if ( nRet != 0 ) 
		return 0;

	// жϸöǷ;
	CDataImpl db;
	if ( !db.Open() )
		return -2;

	// ѯmid;
	nRet = db.QueryMidInfo(order, local_mid);
	if ( nRet == -1)
		return -3;

	if ( nRet == 0 )
	{
		// mid;
		db.InsertMidInfo(host_mid);
	}
	else if ( nRet == 1 )
	{
		// Ƿع,عĲ;
		if ( local_mid.status == "1" && local_mid.finish_date.size() )
			return 2;

		// Mid;
		db.UpdateMidInfo(host_mid);
	}
	else if ( nRet > 1 )
		return -4;
	
	// ;
	CSDK::AddDownloadTask(host_mid);

	return 1;
}

int CSDK::QueryKeyInfo(std::string sn, STKeys &keys)
{
	if ( sn.size() == 0 )
		return -1;

	CDataImpl db;
	if ( !db.Open() )
		return -2;

	int nRow = db.QueryKeyInfo(sn.c_str(), keys);
	if ( nRow == -1)
		return -3;

	if ( nRow == 0 )
		return 0;

	if ( nRow == 1 )
		return 1;

	return -4;
}

int CSDK::UpdateKeyCopyStatus(std::string sn )
{
	if ( sn.size() == 0 )
		return -1;

	CDataImpl db;
	if ( !db.Open() )
		return -2;

	BOOL bRet = FALSE;
	// ֻ³дɹ״̬;
	bRet = db.UpdateKeyCopyStatus(sn.c_str());	
	
	return bRet == TRUE ? 1 : 0;
}

int CSDK::UpdateKeyReportStatus(std::string sn)
{
	if ( sn.size() == 0 )
		return -1;

	CDataImpl db;
	if ( !db.Open() )
		return -2;

	BOOL bRet = FALSE;
	// ³дɹ״̬1ʧ-1;
	bRet = db.UpdateKeyReportStatus(sn.c_str());
	
	return bRet == TRUE ? 1 : 0;
}

int CSDK::ReportKeyCopyResults(std::string sn)
{
	if ( sn.size() == 0 )
		return -1;

	CDataImpl db;
	if ( !db.Open() )
		return -2;

	STKeys keys;
	int nRet = db.QueryKeyInfo(sn.c_str(), keys);
	if ( nRet == -1)
		return -3;

	if ( nRet == 0 )
		return 0;

	if ( nRet == 1 )
	{
		// ϱ;
		std::string result;
		std::multimap<std::string, std::string> form;
		form.insert(std::pair<std::string,std::string>("sn", sn));
		form.insert(std::pair<std::string,std::string>("date", keys.copy_date));
		CCurlClient curl;
		curl.Initialize();
		if ( curl.FormPosts(_host + "/reportlist.do?", form, result,3) == CURLE_OK)
		{
			cJSON *pJson = cJSON_Parse(result.c_str());
			if ( pJson == NULL )
			{
				return -6;
			}

			std::string code, des;
			code = cJSON_GetObjectItem(pJson, "code") ? cJSON_GetObjectItem(pJson, "code")->valuestring: "";
			des = cJSON_GetObjectItem(pJson, "des") ? cJSON_GetObjectItem(pJson, "des")->valuestring: "";
			if ( _tcsicmp(code.c_str(), "1000") )
			{
				cJSON_Delete(pJson);
				return -7;
			}
			cJSON_Delete(pJson);

			// ϱ״̬;
			nRet = db.UpdateKeyReportStatus(sn);
			if ( nRet == 1 )
				return 1;
			else
				return -8; // ϱɹʧ;
		}

		return -5;
	}
	
	return -4;
}

int CSDK::BatchReportKeyCopyResults()
{
	CDataImpl db;
	if ( !db.Open() )
		return -2;

	std::vector<STKeys> vtkeys;
	int nRet = db.QueryUnReportKeyInfo(vtkeys);
	if ( nRet == -1)
		return -3;

	if ( nRet == 0 )
		return 0;

	// ϱ;
	std::string result;
	std::multimap<std::string, std::string> form;
	std::vector<STKeys>::iterator it = vtkeys.begin();
	for (; it != vtkeys.end(); it++)
	{
		form.insert(std::pair<std::string,std::string>("sn", it->sn));
		form.insert(std::pair<std::string,std::string>("date", it->copy_date));
	}

	CCurlClient curl;
	curl.Initialize();
	if ( curl.FormPosts(_host + "/reportlist.do?", form, result) == CURLE_OK)
	{
		cJSON *pJson = cJSON_Parse(result.c_str());
		if ( pJson == NULL )
		{
			return -6;
		}

		std::string code, des;
		code = cJSON_GetObjectItem(pJson, "code") ? cJSON_GetObjectItem(pJson, "code")->valuestring: "";
		des = cJSON_GetObjectItem(pJson, "des") ? cJSON_GetObjectItem(pJson, "des")->valuestring: "";
		if ( _tcsicmp(code.c_str(), "1000") )
		{
			cJSON_Delete(pJson);
			return -7;
		}
		cJSON_Delete(pJson);

		// ϱ״̬;
		nRet = db.BatchUpdateKeyReportStatus(vtkeys);
		if ( nRet == 1 )
			return 1;
		else
			return -8; // ϱɹʧ;
	}

	return -5;

}

void CSDK::AddDownloadTask(STMid &mid)
{
	AutoThreadSection ats(&g_csTask);
	bool has = false;
	std::list<STMid>::iterator it = m_vtMidTask.begin();
	for (; it != m_vtMidTask.end(); it++ )
	{
		if ( _tcsicmp(it->order.c_str(), mid.order.c_str()) == 0 )
		{
			has = true;
			*it = mid; // ;
			break;
		}
	}

	if ( !has )
	{
		m_vtMidTask.push_back(mid);
	}
}

BOOL CSDK::PopDownloadTask(STMid &mid)
{
	AutoThreadSection ats(&g_csTask);
	if ( m_vtMidTask.size() )
	{
		mid = m_vtMidTask.front();
		m_vtMidTask.pop_front();
		return TRUE;
	}

	return FALSE;
}

bool CSDK::CheckDownload(std::string file, STMid& mid)
{
	// Уļmd5ֵ;
	std::string fileMd5 = GetFileMD5(file.c_str());
	if ( _tcsicmp(fileMd5.c_str(), mid.pmd5.c_str()) == 0 )
	{
		// ļسɹ,ݿ;
		std::vector<STKeys> vtKeys;
		ParserKey(file, vtKeys, mid);
		if ( vtKeys.size() )
		{
			CDataImpl db;
			if ( db.Open() )
			{
				if ( db.BatchInsertKeyInfo(vtKeys) == 0 )
				{
					// ״̬;
					if ( ReportDownloadStatus(mid.order) == 0 )
					{
						if ( db.UpdateDownloadStatus(mid.order, 1) )
							return true;
					}
				}
			}
		}
	}

	return false;
}

int CSDK::GetMidInfo(std::string order, STMid &mid)
{
	int nRet = 0;
	// httpȡmid;
	std::string result;
	std::string url = _host + "/getofflinelist.do?";
	std::string content = "orderNumber=";
	content.append(order);
	//content.append("&mac=");
	//content.append(Global::g_strMacs);
	CCurlClient curl;
	curl.Initialize();
	if ( (nRet = curl.Posts(url, content, result)) == CURLE_OK)
	{
		// jsonַ;
		cJSON *pJson = cJSON_Parse(result.c_str());
		if ( !pJson )
		{
			return -2;
		}

		std::string code, des;
		code = cJSON_GetObjectItem(pJson, _T("code")) ? cJSON_GetObjectItem(pJson, _T("code"))->valuestring : "";
		des = cJSON_GetObjectItem(pJson, _T("des")) ? cJSON_GetObjectItem(pJson, _T("des"))->valuestring : "";
		cJSON *pData = cJSON_GetObjectItem(pJson, _T("data"));
		if ( _tcsicmp(code.c_str(), "1000") )
		{
			cJSON_Delete(pJson);
			Global::WriteTextLog("getofflinelist.doʧ,=%s", result.c_str());
			return -3;
		}
		
		if ( !pData )
		{
			cJSON_Delete(pJson);
			Global::WriteTextLog("getofflinelist.doʧ,data=%s", result.c_str());
			return -4;
		}

		TCHAR szData[10] = {0};
		mid.order = cJSON_GetObjectItem(pData, _T("order_number")) ? cJSON_GetObjectItem(pData, _T("order_number"))->valuestring : "";
		mid.version = cJSON_GetObjectItem(pData, _T("soft_version")) ? cJSON_GetObjectItem(pData, _T("soft_version"))->valuestring : "";
		//mid.number = cJSON_GetObjectItem(pData, _T("order_quantity")) ? cJSON_GetObjectItem(pData, _T("order_quantity"))->valuestring : "";
		_itoa_s(cJSON_GetObjectItem(pData, _T("order_quantity")) ? cJSON_GetObjectItem(pData, _T("order_quantity"))->valueint : 0, szData, 10);
		mid.number = szData;
		mid.pmd5 = cJSON_GetObjectItem(pData, _T("packet_md5")) ? cJSON_GetObjectItem(pData, _T("packet_md5"))->valuestring : "";
		mid.ctype = cJSON_GetObjectItem(pData, _T("client_type")) ? cJSON_GetObjectItem(pData, _T("client_type"))->valuestring : "";
		mid.pid = cJSON_GetObjectItem(pData, _T("project_id")) ? cJSON_GetObjectItem(pData, _T("project_id"))->valuestring : "";
		//mid.purl = cJSON_GetObjectItem(pData, _T("packet_url")) ? cJSON_GetObjectItem(pData, _T("packet_url"))->valuestring : "";
		_GET_JSON_STRING(pData, _T("packet_url"), mid.purl);
		//mid.psize = cJSON_GetObjectItem(pData, _T("packet_size")) ? cJSON_GetObjectItem(pData, _T("packet_size"))->valuestring : "";
		memset(szData, 0, 10);
		_itoa_s(cJSON_GetObjectItem(pData, _T("packet_size")) ? cJSON_GetObjectItem(pData, _T("packet_size"))->valueint : 0, szData, 10);
		mid.psize = szData;

		cJSON_Delete(pJson);
		pJson = NULL;

		return 0;
	}
	else
	{
		Global::WriteTextLog("getofflinelist.do,=%ld", nRet);
	}

	// http쳣;
	return -1;
}

BOOL CSDK::HttpPost(std::string host, std::string context, std::string &result, DATATYPE dt)
{
	CCurlClient curl;
	curl.Initialize();
	CharEncoding::ASCII2UTF8(context.c_str(), context);
	curl.SetHeaders("Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, application/x-shockwave-flash, application/x-silverlight, application/x-ms-application, application/x-ms-xbap, application/vnd.ms-xpsdocument, application/xaml+xml, */*");
	curl.SetHeaders("Accept-Language: zh-cn");
	if (dt == DATA_JSON)
		curl.SetHeaders("Content-Type: application/json;charset=utf-8");

	int nRecCode = CURLE_OK;
	if (_tcsstr(host.c_str(), "https://"))
		nRecCode = curl.Posts(host, context, result);
	else
		nRecCode = curl.Posts(host, context, result);

	result = CharEncoding::DeCode_URLUTF8(result.c_str());
	if ( nRecCode != CURLE_OK )
		Global::WriteTextLog("https,=%ld", nRecCode);

	return CURLE_OK == nRecCode;
}

BOOL CSDK::GetBidInfo(std::string order, std::string macs)
{
	// Json;
	cJSON *pJson = cJSON_CreateObject();
	cJSON_AddStringToObject(pJson, "clientType", "");
	cJSON_AddStringToObject(pJson, "version", "");
	cJSON_AddStringToObject(pJson, "mac", macs.c_str());
	cJSON_AddStringToObject(pJson, "bid", order.c_str());
	char *pJsonText = cJSON_Print(pJson);

	// post;
	std::string name, type;
	std::string host, result, context;
	context = pJsonText;

	if (pJsonText)
		free(pJsonText);
	pJsonText = NULL;
	cJSON_Delete(pJson);
	pJson = NULL;

	std::string code, message;
	host = Global::g_bTestHost ? _T("http://test.admin.uc.qhmoka.com/scbc-server/clientType/getMessage.do") : _T("https://cn.uc.qhmoka.com/scbc-server/clientType/getMessage.do");
	BOOL bRet = HttpPost(host, context, result, DATA_JSON);
	if (!bRet)
	{
		Global::WriteTextLog("getMessage.doʧ");
		goto end;
	}

	// ֵ;
	pJson = cJSON_Parse(result.c_str());
	if (pJson == NULL)
	{
		bRet = FALSE;
		Global::WriteTextLog("getMessage.do Jsonʧܣ%s", result.c_str());
		goto end;
	}

	message = cJSON_GetObjectItem(pJson, "message") ? cJSON_GetObjectItem(pJson, "message")->valuestring : "";
	code = cJSON_GetObjectItem(pJson, "code") ? cJSON_GetObjectItem(pJson, "code")->valuestring : "";
	_host = cJSON_GetObjectItem(pJson, "host") ? (cJSON_GetObjectItem(pJson, "host")->valuestring != NULL ? cJSON_GetObjectItem(pJson, "host")->valuestring : "") : "";
	
	if (_tcsicmp(code.c_str(), "1000") != 0)
	{
		bRet = FALSE;
		Global::WriteTextLog("getMessage.do Code%s", result.c_str());
		goto end;
	}

	if (_host.size() == 0)
	{
		bRet = FALSE;
		Global::WriteTextLog("getMessage.do host%s", result.c_str());
		goto end;
	}

end:
	// ͷJson;
	if (pJsonText)
		free(pJsonText);
	pJsonText = NULL;
	cJSON_Delete(pJson);

	return bRet;
}

int CSDK::ReportDownloadStatus(std::string order)
{
	// httpȡmid;
	std::string result;
	std::string url = _host + "/getreportofflinesn.do?";
	std::string content = "orderNumber=";
	content.append(order);

	int nRet = 0;
	CCurlClient curl;
	curl.Initialize();
	if ( ( nRet = curl.Posts(url, content, result)) == CURLE_OK)
	{
		// jsonַ;
		cJSON *pJson = cJSON_Parse(result.c_str());
		if ( !pJson )
		{
			return -2;
		}

		std::string code, des;
		code = cJSON_GetObjectItem(pJson, _T("code")) ? cJSON_GetObjectItem(pJson, _T("code"))->valuestring : "";
		des = cJSON_GetObjectItem(pJson, _T("des")) ? cJSON_GetObjectItem(pJson, _T("des"))->valuestring : "";

		if ( _tcsicmp(code.c_str(), "1000") && _tcsicmp(code.c_str(), "1006") && _tcsicmp(code.c_str(), "1007") )
		{
			cJSON_Delete(pJson);
			Global::WriteTextLog("getofflinelist.doʧ,=%s", result.c_str());
			return -3;
		}

		cJSON_Delete(pJson);
		pJson = NULL;

		return 0;
	}
	else
	{
		Global::WriteTextLog("getofflinelist.do,=%ld", nRet);
	}

	// http쳣;
	return -1;
}

void CSDK::ParserKey(std::string file, std::vector<STKeys> &vtKyes, STMid &mid)
{
	// ȡļ;
	FILE* pf = NULL;
	_tfopen_s(&pf, file.c_str(), _T("rb"));
	if (!pf)
		return;
	// ȡļ;
	fseek(pf, 0, SEEK_END);
	size_t file_size = ftell(pf);
	fseek(pf, 0, SEEK_SET);
	// ȡļ;
	byte* pdata = (byte*)malloc(file_size);
	fread(pdata, file_size, 1, pf);
	fclose(pf);

	// Json;
	cJSON* pJson = cJSON_Parse((const char*)pdata);
	if (pJson == NULL)
	{
		Global::WriteTextLog("ParserKey Jsonʧ");
		goto end;
	}

	//////////////////////////////////////////////////////////////////////////
	// Json;
	cJSON *pItem = NULL;
	int nCount = cJSON_GetArraySize(pJson);
	for ( int i = 0; i < nCount; i++ )
	{
		pItem = cJSON_GetArrayItem(pJson, i);
		if ( pItem )
		{
			STKeys key;
			key.bid = mid.order;
			key.pid = mid.pid;
			// к;
			key.sn = cJSON_GetObjectItem(pItem, _T("sn")) ? cJSON_GetObjectItem(pItem, _T("sn"))->valuestring : "";
			cJSON *pJsonKeys = cJSON_GetObjectItem(pItem, _T("key"));
			if ( pJsonKeys )
			{
				char *lpszKeys = cJSON_Print(pJsonKeys);
				if ( lpszKeys)
				{
					key.keys = lpszKeys;
					free(lpszKeys);
				}
			}
			vtKyes.push_back(key);
		}
	}

end:
	if (pdata)
		free(pdata);

	if (pJson)
		cJSON_Delete(pJson);
}

bool CSDK::ParserSNKey(std::string json, SNKeys &snKey)
{
	bool bRet = false;
	// Json;
	cJSON* pJson = cJSON_Parse(json.c_str());
	if ( pJson )
	{
		// к;
		snKey.did = cJSON_GetObjectItem(pJson, _T("sn")) ? cJSON_GetObjectItem(pJson, _T("sn"))->valuestring : "";
		snKey.mac = cJSON_GetObjectItem(pJson, _T("keys")) ? cJSON_GetObjectItem(pJson, _T("keys"))->valuestring : "";
		snKey.hdcp = cJSON_GetObjectItem(pJson, _T("keys")) ? cJSON_GetObjectItem(pJson, _T("keys"))->valuestring : "";
		snKey.hdcp22 = cJSON_GetObjectItem(pJson, _T("keys")) ? cJSON_GetObjectItem(pJson, _T("keys"))->valuestring : "";
		snKey.widi = cJSON_GetObjectItem(pJson, _T("keys")) ? cJSON_GetObjectItem(pJson, _T("keys"))->valuestring : "";
		snKey.widevine = cJSON_GetObjectItem(pJson, _T("keys")) ? cJSON_GetObjectItem(pJson, _T("keys"))->valuestring : "";
		snKey.esn = cJSON_GetObjectItem(pJson, _T("keys")) ? cJSON_GetObjectItem(pJson, _T("keys"))->valuestring : "";
		snKey.cikey = cJSON_GetObjectItem(pJson, _T("keys")) ? cJSON_GetObjectItem(pJson, _T("keys"))->valuestring : "";

		bRet = true;
	}
	else
	{
		Global::WriteTextLog("ParserSNKey Jsonʧ");
	}

	if (pJson)
		cJSON_Delete(pJson);

	return bRet;
}

DWORD CSDK::ThreadDownload(LPVOID lpParam)
{
	CSDK *that = (CSDK*)lpParam;
	// keyļ·;
	TCHAR szKeyPacket[MAX_PATH] = {0};
	do 
	{
		if ( m_vtMidTask.size() )
		{
			// ȡ;
			STMid mid = m_vtMidTask.front();

			// жļǷڣmd5ֵ;
			_stprintf_s(szKeyPacket, _T("%scache\\%s.json"), Global::g_szCurModuleDir, mid.order.c_str());
 			if ( _taccess(szKeyPacket, 0) != -1 )
			{
				if ( CheckDownload(szKeyPacket, mid) )
				{
					// ;
					AutoThreadSection ats(&g_csTask);
					if ( m_vtMidTask.size() )
					{
						m_vtMidTask.pop_front();
					}

					continue;
				}

				// ļСͬ,ɾļ;
				struct stat fst;
				if ( stat(szKeyPacket, &fst) == 0 )
				{
					if ( atoi(mid.psize.c_str()) == fst.st_size )
						DeleteFile(szKeyPacket);
				}
			}

			// ļ,ʼ;
			CCurlClient curl;
			curl.Initialize();
			curl.DownloadEx(mid.purl, szKeyPacket);
		}
	} while (WaitForSingleObject(that->m_hDownloadEvent, 5000) == WAIT_TIMEOUT );

	return 0L;
}

void CSDK::EndDowloadThread()
{
	if ( m_hDownloadEvent )
	{
		SetEvent(m_hDownloadEvent);
	}

	if ( m_hThreadDownload)
	{
		WaitForSingleObject(m_hThreadDownload, INFINITE);
		CloseHandle(m_hThreadDownload);
		m_hThreadDownload = NULL;

		if ( m_hDownloadEvent )
			CloseHandle(m_hDownloadEvent);
		m_hDownloadEvent = NULL;
	}		 
}

DWORD CSDK::ThreadReport(LPVOID lpParam)
{
	CSDK *that = (CSDK*)lpParam;
	do 
	{
		// Զϱ;

	} while (WaitForSingleObject(that->m_hReportEvent, 3000) == WAIT_TIMEOUT );

	return 0L;
}

void CSDK::EndReportThread()
{
	if ( m_hReportEvent )
	{
		SetEvent(m_hReportEvent);
	}

	if ( m_hThreadReport)
	{
		WaitForSingleObject(m_hThreadReport, INFINITE);
		CloseHandle(m_hThreadReport);
		m_hThreadReport = NULL;

		if ( m_hReportEvent )
			CloseHandle(m_hReportEvent);
		m_hReportEvent = NULL;
	}		 
}